/* digital-clock.c generated by valac 0.13.4, the Vala compiler
 * generated from digital-clock.vala, do not modify */

/*
 * Digital-clock applet for Awn (based on applet by Ryan Rushton)
 *
 * Copyright (C) 2010 Michal Hruby <michal.mhr@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Michal Hruby <michal.mhr@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libawn/libawn.h>
#include <gtk/gtk.h>
#include <libdesktop-agnostic/config.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <float.h>
#include <math.h>
#include <time.h>
#include <config.h>


#define TYPE_DIGITAL_CLOCK (digital_clock_get_type ())
#define DIGITAL_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIGITAL_CLOCK, DigitalClock))
#define DIGITAL_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIGITAL_CLOCK, DigitalClockClass))
#define IS_DIGITAL_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIGITAL_CLOCK))
#define IS_DIGITAL_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIGITAL_CLOCK))
#define DIGITAL_CLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIGITAL_CLOCK, DigitalClockClass))

typedef struct _DigitalClock DigitalClock;
typedef struct _DigitalClockClass DigitalClockClass;
typedef struct _DigitalClockPrivate DigitalClockPrivate;

#define TYPE_DIGITAL_CLOCK_PREFS (digital_clock_prefs_get_type ())
#define DIGITAL_CLOCK_PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIGITAL_CLOCK_PREFS, DigitalClockPrefs))
#define DIGITAL_CLOCK_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIGITAL_CLOCK_PREFS, DigitalClockPrefsClass))
#define IS_DIGITAL_CLOCK_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIGITAL_CLOCK_PREFS))
#define IS_DIGITAL_CLOCK_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIGITAL_CLOCK_PREFS))
#define DIGITAL_CLOCK_PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIGITAL_CLOCK_PREFS, DigitalClockPrefsClass))

typedef struct _DigitalClockPrefs DigitalClockPrefs;
typedef struct _DigitalClockPrefsClass DigitalClockPrefsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DigitalClock {
	AwnAppletSimple parent_instance;
	DigitalClockPrivate * priv;
};

struct _DigitalClockClass {
	AwnAppletSimpleClass parent_class;
};

struct _DigitalClockPrivate {
	GtkMenu* _menu;
	AwnDialog* dialog;
	GtkCalendar* calendar;
	AwnOverlayText* time_overlay;
	AwnOverlayText* am_pm_overlay;
	AwnOverlayText* day_overlay;
	AwnOverlayText* date_overlay;
	DesktopAgnosticConfigClient* client;
	gchar** current_time;
	gint current_time_length1;
	gint _current_time_size_;
	DigitalClockPrefs* prefs;
	gboolean _is_12_hour;
	gboolean _show_date;
	gboolean _date_before_time;
	gchar* _calendar_command;
	gchar* _datetime_command;
};


static gpointer digital_clock_parent_class = NULL;

GType digital_clock_get_type (void) G_GNUC_CONST;
GType digital_clock_prefs_get_type (void) G_GNUC_CONST;
#define DIGITAL_CLOCK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DIGITAL_CLOCK, DigitalClockPrivate))
enum  {
	DIGITAL_CLOCK_DUMMY_PROPERTY,
	DIGITAL_CLOCK_IS_12_HOUR,
	DIGITAL_CLOCK_SHOW_DATE,
	DIGITAL_CLOCK_DATE_BEFORE_TIME,
	DIGITAL_CLOCK_CALENDAR_COMMAND,
	DIGITAL_CLOCK_DATETIME_COMMAND
};
#define DIGITAL_CLOCK_EVOLUTION_COMMAND "evolution calendar:///?startdate=%(year)02d%(month)02d%(day)02dT120000"
#define DIGITAL_CLOCK_TIME_ADMIN_COMMAND "gksudo time-admin"
DigitalClock* digital_clock_new (const gchar* canonical_name, const gchar* uid, gint panel_id);
DigitalClock* digital_clock_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id);
static void digital_clock_on_clicked (DigitalClock* self);
static void _digital_clock_on_clicked_awn_applet_simple_clicked (AwnAppletSimple* _sender, gpointer self);
static void digital_clock_on_context_menu_popup (DigitalClock* self, GdkEventButton* event);
static void _digital_clock_on_context_menu_popup_awn_applet_simple_context_menu_popup (AwnAppletSimple* _sender, GdkEventButton* event, gpointer self);
static void digital_clock_refresh_overlays (DigitalClock* self);
static void _digital_clock_refresh_overlays_awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self);
static void _digital_clock_refresh_overlays_awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self);
static void digital_clock_force_refresh (DigitalClock* self);
static void _digital_clock_force_refresh_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void digital_clock_update_clock (DigitalClock* self);
static gboolean __lambda7_ (DigitalClock* self);
static gboolean ___lambda7__gsource_func (gpointer self);
static void digital_clock_init_calendar (DigitalClock* self);
static void digital_clock_start_external_calendar (DigitalClock* self, GtkCalendar* calendar);
static void _digital_clock_start_external_calendar_gtk_calendar_day_selected_double_click (GtkCalendar* _sender, gpointer self);
const gchar* digital_clock_get_calendar_command (DigitalClock* self);
gboolean digital_clock_get_show_date (DigitalClock* self);
gboolean digital_clock_get_date_before_time (DigitalClock* self);
gboolean digital_clock_get_is_12_hour (DigitalClock* self);
static gboolean digital_clock_time_string_changed (DigitalClock* self);
static gchar** digital_clock_get_time_string (DigitalClock* self, int* result_length1);
static gchar** _vala_array_dup1 (gchar** self, int length);
static gchar** _vala_array_dup2 (gchar** self, int length);
static gchar* digital_clock_format_current_time (const gchar* format);
static void ___lambda3_ (DigitalClock* self, GtkMenuItem* w);
static void ____lambda3__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda4_ (DigitalClock* self, GtkMenuItem* w);
static void ____lambda4__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda5_ (DigitalClock* self, GtkMenuItem* w);
const gchar* digital_clock_get_datetime_command (DigitalClock* self);
static void ____lambda5__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda6_ (DigitalClock* self, GtkMenuItem* w);
DigitalClockPrefs* digital_clock_prefs_new (AwnApplet* applet);
DigitalClockPrefs* digital_clock_prefs_construct (GType object_type, AwnApplet* applet);
GtkDialog* digital_clock_prefs_get_dialog (DigitalClockPrefs* self);
static void ____lambda6__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
void digital_clock_set_is_12_hour (DigitalClock* self, gboolean value);
void digital_clock_set_show_date (DigitalClock* self, gboolean value);
void digital_clock_set_date_before_time (DigitalClock* self, gboolean value);
void digital_clock_set_calendar_command (DigitalClock* self, const gchar* value);
void digital_clock_set_datetime_command (DigitalClock* self, const gchar* value);
static void digital_clock_finalize (GObject* obj);
static void _vala_digital_clock_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_digital_clock_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* DIGITAL_CLOCK_authors[1] = {"Michal Hruby <michal.mhr@gmail.com>"};

static void _digital_clock_on_clicked_awn_applet_simple_clicked (AwnAppletSimple* _sender, gpointer self) {
	digital_clock_on_clicked (self);
}


static void _digital_clock_on_context_menu_popup_awn_applet_simple_context_menu_popup (AwnAppletSimple* _sender, GdkEventButton* event, gpointer self) {
	digital_clock_on_context_menu_popup (self, event);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _digital_clock_refresh_overlays_awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self) {
	digital_clock_refresh_overlays (self);
}


static void _digital_clock_refresh_overlays_awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self) {
	digital_clock_refresh_overlays (self);
}


static void _digital_clock_force_refresh_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	digital_clock_force_refresh (self);
}


static gboolean __lambda7_ (DigitalClock* self) {
	gboolean result = FALSE;
	digital_clock_update_clock (self);
	result = TRUE;
	return result;
}


static gboolean ___lambda7__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda7_ (self);
	return result;
}


DigitalClock* digital_clock_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id) {
	DigitalClock * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_ = NULL;
	DesktopAgnosticConfigClient* _tmp4_ = NULL;
	DesktopAgnosticConfigClient* _tmp5_;
	DesktopAgnosticConfigClient* _tmp6_;
	DesktopAgnosticConfigClient* _tmp7_;
	DesktopAgnosticConfigClient* _tmp8_;
	DesktopAgnosticConfigClient* _tmp9_;
	DesktopAgnosticConfigClient* _tmp10_;
	DesktopAgnosticConfigClient* _tmp11_;
	AwnOverlayText* _tmp12_;
	AwnOverlayText* _tmp13_;
	AwnOverlayText* _tmp14_;
	AwnOverlayText* _tmp15_;
	AwnOverlayText* _tmp16_;
	AwnOverlayText* _tmp17_;
	AwnOverlayText* _tmp18_;
	AwnOverlayText* _tmp19_;
	AwnOverlayText* _tmp20_;
	AwnOverlayText* _tmp21_;
	AwnOverlayText* _tmp22_;
	AwnOverlayText* _tmp23_;
	AwnOverlayText* _tmp24_;
	AwnOverlayText* _tmp25_;
	AwnOverlayText* _tmp26_;
	AwnOverlayText* _tmp27_;
	GdkPixbuf* _tmp28_;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp29_;
	GdkPixbuf* _tmp30_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	self = (DigitalClock*) g_object_new (object_type, "canonical-name", _tmp0_, "uid", _tmp1_, "panel-id", _tmp2_, NULL);
	_tmp3_ = _ ("Digital Clock");
	g_object_set ((AwnApplet*) self, "display-name", _tmp3_, NULL);
	g_signal_connect_object ((AwnAppletSimple*) self, "clicked", (GCallback) _digital_clock_on_clicked_awn_applet_simple_clicked, self, 0);
	g_signal_connect_object ((AwnAppletSimple*) self, "context-menu-popup", (GCallback) _digital_clock_on_context_menu_popup_awn_applet_simple_context_menu_popup, self, 0);
	_tmp4_ = awn_config_get_default_for_applet ((AwnApplet*) self, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp6_ = _g_object_ref0 (_tmp5_);
	_g_object_unref0 (self->priv->client);
	self->priv->client = _tmp6_;
	_tmp7_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp7_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "hour12", (GObject*) self, "is_12_hour", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp8_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp8_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "show_date", (GObject*) self, "show_date", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp9_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp9_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "dbt", (GObject*) self, "date_before_time", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp10_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp10_, "commands", "calendar", (GObject*) self, "calendar_command", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp11_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp11_, "commands", "adjust_datetime", (GObject*) self, "datetime_command", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp12_ = awn_overlay_text_new ();
	_tmp13_ = g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->time_overlay);
	self->priv->time_overlay = _tmp13_;
	_tmp14_ = self->priv->time_overlay;
	awn_overlay_set_apply_effects ((AwnOverlay*) _tmp14_, TRUE);
	_tmp15_ = self->priv->time_overlay;
	awn_overlayable_add_overlay ((AwnOverlayable*) self, (AwnOverlay*) _tmp15_);
	_tmp16_ = awn_overlay_text_new ();
	_tmp17_ = g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->am_pm_overlay);
	self->priv->am_pm_overlay = _tmp17_;
	_tmp18_ = self->priv->am_pm_overlay;
	awn_overlay_set_apply_effects ((AwnOverlay*) _tmp18_, TRUE);
	_tmp19_ = self->priv->am_pm_overlay;
	awn_overlayable_add_overlay ((AwnOverlayable*) self, (AwnOverlay*) _tmp19_);
	_tmp20_ = awn_overlay_text_new ();
	_tmp21_ = g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->day_overlay);
	self->priv->day_overlay = _tmp21_;
	_tmp22_ = self->priv->day_overlay;
	awn_overlay_set_apply_effects ((AwnOverlay*) _tmp22_, TRUE);
	_tmp23_ = self->priv->day_overlay;
	awn_overlayable_add_overlay ((AwnOverlayable*) self, (AwnOverlay*) _tmp23_);
	_tmp24_ = awn_overlay_text_new ();
	_tmp25_ = g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->date_overlay);
	self->priv->date_overlay = _tmp25_;
	_tmp26_ = self->priv->date_overlay;
	awn_overlay_set_apply_effects ((AwnOverlay*) _tmp26_, TRUE);
	_tmp27_ = self->priv->date_overlay;
	awn_overlayable_add_overlay ((AwnOverlayable*) self, (AwnOverlay*) _tmp27_);
	_tmp28_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, 1, 1);
	pixbuf = _tmp28_;
	_tmp29_ = pixbuf;
	gdk_pixbuf_fill (_tmp29_, (guint32) 0);
	_tmp30_ = pixbuf;
	awn_applet_simple_set_icon_pixbuf ((AwnAppletSimple*) self, _tmp30_);
	g_signal_connect_object ((AwnApplet*) self, "position-changed", (GCallback) _digital_clock_refresh_overlays_awn_applet_position_changed, self, 0);
	g_signal_connect_object ((AwnApplet*) self, "size-changed", (GCallback) _digital_clock_refresh_overlays_awn_applet_size_changed, self, 0);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _digital_clock_force_refresh_g_object_notify, self, 0);
	digital_clock_refresh_overlays (self);
	digital_clock_update_clock (self);
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ___lambda7__gsource_func, g_object_ref (self), g_object_unref);
	digital_clock_init_calendar (self);
	_g_object_unref0 (pixbuf);
	return self;
}


DigitalClock* digital_clock_new (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	return digital_clock_construct (TYPE_DIGITAL_CLOCK, canonical_name, uid, panel_id);
}


static void _digital_clock_start_external_calendar_gtk_calendar_day_selected_double_click (GtkCalendar* _sender, gpointer self) {
	digital_clock_start_external_calendar (self, _sender);
}


static void digital_clock_init_calendar (DigitalClock* self) {
	AwnDialog* _tmp0_;
	AwnDialog* _tmp1_;
	AwnDialog* _tmp2_;
	GtkCalendar* _tmp3_;
	GtkCalendar* _tmp4_;
	GtkCalendar* _tmp5_;
	GtkCalendar* _tmp6_;
	AwnDialog* _tmp7_;
	const gchar* _tmp8_ = NULL;
	AwnDialog* _tmp9_;
	GtkCalendar* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (AwnDialog*) awn_dialog_new_for_widget ((GtkWidget*) self);
	_tmp1_ = g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->dialog);
	self->priv->dialog = _tmp1_;
	_tmp2_ = self->priv->dialog;
	g_object_set (_tmp2_, "hide-on-unfocus", TRUE, NULL);
	_tmp3_ = (GtkCalendar*) gtk_calendar_new ();
	_tmp4_ = g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->calendar);
	self->priv->calendar = _tmp4_;
	_tmp5_ = self->priv->calendar;
	gtk_calendar_set_display_options (_tmp5_, (GTK_CALENDAR_SHOW_HEADING | GTK_CALENDAR_SHOW_DAY_NAMES) | GTK_CALENDAR_SHOW_WEEK_NUMBERS);
	_tmp6_ = self->priv->calendar;
	g_signal_connect_object (_tmp6_, "day-selected-double-click", (GCallback) _digital_clock_start_external_calendar_gtk_calendar_day_selected_double_click, self, 0);
	_tmp7_ = self->priv->dialog;
	_tmp8_ = _ ("Calendar");
	gtk_window_set_title ((GtkWindow*) _tmp7_, _tmp8_);
	_tmp9_ = self->priv->dialog;
	_tmp10_ = self->priv->calendar;
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
}


static void digital_clock_start_external_calendar (DigitalClock* self, GtkCalendar* calendar) {
	guint year = 0U;
	guint month = 0U;
	guint day = 0U;
	GtkCalendar* _tmp0_;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	guint _tmp4_;
	guint _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* python_cmd;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (calendar != NULL);
	_tmp0_ = calendar;
	gtk_calendar_get_date (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
	year = _tmp1_;
	month = _tmp2_;
	day = _tmp3_;
	_tmp4_ = month;
	month = _tmp4_ + 1;
	_tmp5_ = month;
	_tmp6_ = g_strdup_printf ("data = {'year': %u, 'month': %u, 'day': %u};", year, _tmp5_, day);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat ("python -c \"" "import subprocess;", _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->_calendar_command;
	_tmp11_ = g_strdup_printf ("command = '%s';", _tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat (_tmp9_, _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_strconcat (_tmp14_, "subprocess.Popen(command % data, shell=True);", NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strconcat (_tmp16_, "\"", NULL);
	_tmp18_ = _tmp17_;
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	python_cmd = _tmp18_;
	g_spawn_command_line_async (python_cmd, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_free0 (python_cmd);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (python_cmd);
}


static void digital_clock_force_refresh (DigitalClock* self) {
	g_return_if_fail (self != NULL);
	self->priv->current_time = (_vala_array_free (self->priv->current_time, self->priv->current_time_length1, (GDestroyNotify) g_free), NULL);
	self->priv->current_time = NULL;
	self->priv->current_time_length1 = 0;
	self->priv->_current_time_size_ = self->priv->current_time_length1;
	digital_clock_refresh_overlays (self);
	digital_clock_update_clock (self);
}


static void digital_clock_refresh_overlays (DigitalClock* self) {
	GtkPositionType _tmp0_ = 0;
	GtkPositionType position;
	gint _tmp1_ = 0;
	gint size;
	AwnOverlayText* _tmp2_;
	AwnOverlayText* _tmp3_;
	gboolean _tmp4_;
	AwnOverlayText* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_ = FALSE;
	GtkPositionType _tmp8_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_get_pos_type ((AwnApplet*) self);
	position = _tmp0_;
	_tmp1_ = awn_applet_get_size ((AwnApplet*) self);
	size = _tmp1_;
	_tmp2_ = self->priv->am_pm_overlay;
	g_object_set ((AwnOverlay*) _tmp2_, "active", FALSE, NULL);
	_tmp3_ = self->priv->day_overlay;
	_tmp4_ = self->priv->_show_date;
	g_object_set ((AwnOverlay*) _tmp3_, "active", _tmp4_, NULL);
	_tmp5_ = self->priv->date_overlay;
	_tmp6_ = self->priv->_show_date;
	g_object_set ((AwnOverlay*) _tmp5_, "active", _tmp6_, NULL);
	_tmp8_ = position;
	if (_tmp8_ == GTK_POS_TOP) {
		_tmp7_ = TRUE;
	} else {
		GtkPositionType _tmp9_;
		_tmp9_ = position;
		_tmp7_ = _tmp9_ == GTK_POS_BOTTOM;
	}
	_tmp10_ = _tmp7_;
	if (_tmp10_) {
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_;
		gboolean _tmp14_;
		_tmp12_ = self->priv->_date_before_time;
		if (_tmp12_) {
			_tmp11_ = TRUE;
		} else {
			gboolean _tmp13_;
			_tmp13_ = self->priv->_show_date;
			_tmp11_ = !_tmp13_;
		}
		_tmp14_ = _tmp11_;
		if (_tmp14_) {
			gint _tmp15_ = 0;
			gboolean _tmp16_;
			gint _tmp19_;
			gint width;
			AwnIcon* _tmp20_ = NULL;
			gint _tmp21_;
			gint _tmp22_;
			gint _tmp23_ = 0;
			gboolean _tmp24_;
			AwnOverlayText* _tmp25_;
			gint _tmp26_;
			GdkGravity _tmp27_ = 0;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_;
			gboolean _tmp31_;
			AwnOverlayText* _tmp32_;
			GdkGravity _tmp33_;
			AwnOverlayText* _tmp34_;
			AwnOverlayText* _tmp35_;
			AwnOverlayText* _tmp36_;
			AwnOverlayText* _tmp37_;
			AwnOverlayText* _tmp38_;
			gboolean _tmp39_;
			_tmp16_ = self->priv->_show_date;
			if (_tmp16_) {
				gint _tmp17_;
				_tmp17_ = size;
				_tmp15_ = (_tmp17_ * 11) / 5;
			} else {
				gint _tmp18_;
				_tmp18_ = size;
				_tmp15_ = (_tmp18_ * 3) / 2;
			}
			_tmp19_ = _tmp15_;
			width = _tmp19_;
			_tmp20_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
			_tmp21_ = width;
			_tmp22_ = size;
			awn_icon_set_custom_paint (_tmp20_, _tmp21_, _tmp22_);
			_tmp24_ = self->priv->_show_date;
			if (_tmp24_) {
				_tmp23_ = 22;
			} else {
				_tmp23_ = 25;
			}
			_tmp25_ = self->priv->time_overlay;
			_tmp26_ = _tmp23_;
			g_object_set (_tmp25_, "font-sizing", (gdouble) _tmp26_, NULL);
			_tmp29_ = self->priv->_show_date;
			if (_tmp29_) {
				_tmp28_ = TRUE;
			} else {
				gboolean _tmp30_;
				_tmp30_ = self->priv->_is_12_hour;
				_tmp28_ = _tmp30_;
			}
			_tmp31_ = _tmp28_;
			if (_tmp31_) {
				_tmp27_ = GDK_GRAVITY_NORTH_EAST;
			} else {
				_tmp27_ = GDK_GRAVITY_CENTER;
			}
			_tmp32_ = self->priv->time_overlay;
			_tmp33_ = _tmp27_;
			g_object_set ((AwnOverlay*) _tmp32_, "gravity", _tmp33_, NULL);
			_tmp34_ = self->priv->day_overlay;
			g_object_set (_tmp34_, "font-sizing", (gdouble) 14, NULL);
			_tmp35_ = self->priv->day_overlay;
			g_object_set ((AwnOverlay*) _tmp35_, "gravity", GDK_GRAVITY_WEST, NULL);
			_tmp36_ = self->priv->day_overlay;
			g_object_set ((AwnOverlay*) _tmp36_, "y-adj", (gdouble) 0, NULL);
			_tmp37_ = self->priv->date_overlay;
			g_object_set (_tmp37_, "font-sizing", (gdouble) 14, NULL);
			_tmp38_ = self->priv->date_overlay;
			g_object_set ((AwnOverlay*) _tmp38_, "gravity", GDK_GRAVITY_SOUTH_WEST, NULL);
			_tmp39_ = self->priv->_is_12_hour;
			if (_tmp39_) {
				AwnOverlayText* _tmp40_;
				AwnOverlayText* _tmp41_;
				AwnOverlayText* _tmp42_;
				_tmp40_ = self->priv->am_pm_overlay;
				g_object_set ((AwnOverlay*) _tmp40_, "active", TRUE, NULL);
				_tmp41_ = self->priv->am_pm_overlay;
				g_object_set (_tmp41_, "font-sizing", (gdouble) 14, NULL);
				_tmp42_ = self->priv->am_pm_overlay;
				g_object_set ((AwnOverlay*) _tmp42_, "gravity", GDK_GRAVITY_SOUTH_EAST, NULL);
			}
		} else {
			gint _tmp43_ = 0;
			gboolean _tmp44_;
			gint _tmp47_;
			gint width;
			AwnIcon* _tmp48_ = NULL;
			gint _tmp49_;
			gint _tmp50_;
			gint _tmp51_ = 0;
			gboolean _tmp52_;
			AwnOverlayText* _tmp53_;
			gint _tmp54_;
			AwnOverlayText* _tmp55_;
			AwnOverlayText* _tmp56_;
			AwnOverlayText* _tmp57_;
			AwnOverlayText* _tmp58_;
			AwnOverlayText* _tmp59_;
			AwnOverlayText* _tmp60_;
			_tmp44_ = self->priv->_is_12_hour;
			if (_tmp44_) {
				gint _tmp45_;
				_tmp45_ = size;
				_tmp43_ = (_tmp45_ * 17) / 10;
			} else {
				gint _tmp46_;
				_tmp46_ = size;
				_tmp43_ = (_tmp46_ * 6) / 5;
			}
			_tmp47_ = _tmp43_;
			width = _tmp47_;
			_tmp48_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
			_tmp49_ = width;
			_tmp50_ = size;
			awn_icon_set_custom_paint (_tmp48_, _tmp49_, _tmp50_);
			_tmp52_ = self->priv->_is_12_hour;
			if (_tmp52_) {
				_tmp51_ = 17;
			} else {
				_tmp51_ = 18;
			}
			_tmp53_ = self->priv->time_overlay;
			_tmp54_ = _tmp51_;
			g_object_set (_tmp53_, "font-sizing", (gdouble) _tmp54_, NULL);
			_tmp55_ = self->priv->time_overlay;
			g_object_set ((AwnOverlay*) _tmp55_, "gravity", GDK_GRAVITY_NORTH, NULL);
			_tmp56_ = self->priv->day_overlay;
			g_object_set (_tmp56_, "font-sizing", (gdouble) 14, NULL);
			_tmp57_ = self->priv->day_overlay;
			g_object_set ((AwnOverlay*) _tmp57_, "gravity", GDK_GRAVITY_CENTER, NULL);
			_tmp58_ = self->priv->day_overlay;
			g_object_set ((AwnOverlay*) _tmp58_, "y-adj", 0.05, NULL);
			_tmp59_ = self->priv->date_overlay;
			g_object_set (_tmp59_, "font-sizing", (gdouble) 14, NULL);
			_tmp60_ = self->priv->date_overlay;
			g_object_set ((AwnOverlay*) _tmp60_, "gravity", GDK_GRAVITY_SOUTH, NULL);
		}
	} else {
		gint height = 0;
		gboolean _tmp61_;
		AwnIcon* _tmp64_ = NULL;
		gint _tmp65_;
		gint _tmp66_;
		gint _tmp67_ = 0;
		gboolean _tmp68_;
		AwnOverlayText* _tmp69_;
		gint _tmp70_;
		gboolean _tmp71_;
		GdkGravity _tmp76_ = 0;
		gboolean _tmp77_;
		AwnOverlayText* _tmp78_;
		GdkGravity _tmp79_;
		AwnOverlayText* _tmp80_;
		AwnOverlayText* _tmp81_;
		AwnOverlayText* _tmp82_;
		AwnOverlayText* _tmp83_;
		AwnOverlayText* _tmp84_;
		_tmp61_ = self->priv->_show_date;
		if (_tmp61_) {
			gint _tmp62_;
			_tmp62_ = size;
			height = _tmp62_;
		} else {
			gint _tmp63_;
			_tmp63_ = size;
			height = _tmp63_ / 2;
		}
		_tmp64_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
		_tmp65_ = size;
		_tmp66_ = height;
		awn_icon_set_custom_paint (_tmp64_, _tmp65_, _tmp66_);
		_tmp68_ = self->priv->_is_12_hour;
		if (_tmp68_) {
			_tmp67_ = 10;
		} else {
			_tmp67_ = 15;
		}
		_tmp69_ = self->priv->time_overlay;
		_tmp70_ = _tmp67_;
		g_object_set (_tmp69_, "font-sizing", (gdouble) _tmp70_, NULL);
		_tmp71_ = self->priv->_show_date;
		if (!_tmp71_) {
			AwnOverlayText* _tmp72_;
			AwnOverlayText* _tmp73_;
			gdouble _tmp74_ = 0.0;
			gdouble _tmp75_;
			_tmp72_ = self->priv->time_overlay;
			_tmp73_ = self->priv->time_overlay;
			g_object_get (_tmp73_, "font-sizing", &_tmp74_, NULL);
			_tmp75_ = _tmp74_;
			g_object_set (_tmp73_, "font-sizing", _tmp75_ * 2, NULL);
		}
		_tmp77_ = self->priv->_show_date;
		if (_tmp77_) {
			_tmp76_ = GDK_GRAVITY_NORTH;
		} else {
			_tmp76_ = GDK_GRAVITY_CENTER;
		}
		_tmp78_ = self->priv->time_overlay;
		_tmp79_ = _tmp76_;
		g_object_set ((AwnOverlay*) _tmp78_, "gravity", _tmp79_, NULL);
		_tmp80_ = self->priv->day_overlay;
		g_object_set (_tmp80_, "font-sizing", (gdouble) 12, NULL);
		_tmp81_ = self->priv->day_overlay;
		g_object_set ((AwnOverlay*) _tmp81_, "gravity", GDK_GRAVITY_CENTER, NULL);
		_tmp82_ = self->priv->day_overlay;
		g_object_set ((AwnOverlay*) _tmp82_, "y-adj", 0.05, NULL);
		_tmp83_ = self->priv->date_overlay;
		g_object_set (_tmp83_, "font-sizing", (gdouble) 12, NULL);
		_tmp84_ = self->priv->date_overlay;
		g_object_set ((AwnOverlay*) _tmp84_, "gravity", GDK_GRAVITY_SOUTH, NULL);
	}
}


static void digital_clock_update_clock (DigitalClock* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp6_;
	AwnOverlayText* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	AwnOverlayText* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	const gchar* _tmp25_;
	g_return_if_fail (self != NULL);
	_tmp0_ = digital_clock_time_string_changed (self);
	if (!_tmp0_) {
		return;
	}
	_tmp2_ = self->priv->_is_12_hour;
	if (!_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		AwnOverlayText* _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_;
		_tmp3_ = self->priv->am_pm_overlay;
		g_object_get ((AwnOverlay*) _tmp3_, "active", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	}
	_tmp6_ = _tmp1_;
	if (_tmp6_) {
		AwnOverlayText* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		AwnOverlayText* _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		_tmp7_ = self->priv->time_overlay;
		_tmp8_ = self->priv->current_time;
		_tmp8__length1 = self->priv->current_time_length1;
		_tmp9_ = _tmp8_[0];
		g_object_set (_tmp7_, "text", _tmp9_, NULL);
		_tmp10_ = self->priv->am_pm_overlay;
		_tmp11_ = self->priv->current_time;
		_tmp11__length1 = self->priv->current_time_length1;
		_tmp12_ = _tmp11_[1];
		g_object_set (_tmp10_, "text", _tmp12_, NULL);
	} else {
		AwnOverlayText* _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_;
		_tmp13_ = self->priv->time_overlay;
		_tmp14_ = self->priv->current_time;
		_tmp14__length1 = self->priv->current_time_length1;
		_tmp15_ = _tmp14_[0];
		_tmp16_ = self->priv->current_time;
		_tmp16__length1 = self->priv->current_time_length1;
		_tmp17_ = _tmp16_[1];
		_tmp18_ = g_strdup_printf ("%s %s", _tmp15_, _tmp17_);
		_tmp19_ = _tmp18_;
		g_object_set (_tmp13_, "text", _tmp19_, NULL);
		_g_free0 (_tmp19_);
	}
	_tmp20_ = self->priv->day_overlay;
	_tmp21_ = self->priv->current_time;
	_tmp21__length1 = self->priv->current_time_length1;
	_tmp22_ = _tmp21_[2];
	g_object_set (_tmp20_, "text", _tmp22_, NULL);
	_tmp23_ = self->priv->date_overlay;
	_tmp24_ = self->priv->current_time;
	_tmp24__length1 = self->priv->current_time_length1;
	_tmp25_ = _tmp24_[3];
	g_object_set (_tmp23_, "text", _tmp25_, NULL);
}


static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static gchar** _vala_array_dup2 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static gboolean digital_clock_time_string_changed (DigitalClock* self) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gchar** _tmp1_ = NULL;
	gchar** cur_time;
	gint cur_time_length1;
	gint _cur_time_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = digital_clock_get_time_string (self, &_tmp0_);
	cur_time = _tmp1_;
	cur_time_length1 = _tmp0_;
	_cur_time_size_ = cur_time_length1;
	_tmp2_ = self->priv->current_time;
	_tmp2__length1 = self->priv->current_time_length1;
	if (_tmp2_ == NULL) {
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
		_tmp3_ = cur_time;
		_tmp3__length1 = cur_time_length1;
		_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1) : ((gpointer) _tmp3_);
		_tmp4__length1 = _tmp3__length1;
		self->priv->current_time = (_vala_array_free (self->priv->current_time, self->priv->current_time_length1, (GDestroyNotify) g_free), NULL);
		self->priv->current_time = _tmp4_;
		self->priv->current_time_length1 = _tmp4__length1;
		self->priv->_current_time_size_ = self->priv->current_time_length1;
		result = TRUE;
		cur_time = (_vala_array_free (cur_time, cur_time_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	{
		gint i;
		i = 0;
		{
			gboolean _tmp5_;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_;
				gint _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gint _tmp11_;
				const gchar* _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				gint _tmp14_;
				const gchar* _tmp15_;
				_tmp6_ = _tmp5_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = self->priv->current_time;
				_tmp9__length1 = self->priv->current_time_length1;
				if (!(_tmp8_ < _tmp9__length1)) {
					break;
				}
				_tmp10_ = self->priv->current_time;
				_tmp10__length1 = self->priv->current_time_length1;
				_tmp11_ = i;
				_tmp12_ = _tmp10_[_tmp11_];
				_tmp13_ = cur_time;
				_tmp13__length1 = cur_time_length1;
				_tmp14_ = i;
				_tmp15_ = _tmp13_[_tmp14_];
				if (g_strcmp0 (_tmp12_, _tmp15_) != 0) {
					gchar** _tmp16_;
					gint _tmp16__length1;
					gchar** _tmp17_;
					gint _tmp17__length1;
					_tmp16_ = cur_time;
					_tmp16__length1 = cur_time_length1;
					_tmp17_ = (_tmp16_ != NULL) ? _vala_array_dup2 (_tmp16_, _tmp16__length1) : ((gpointer) _tmp16_);
					_tmp17__length1 = _tmp16__length1;
					self->priv->current_time = (_vala_array_free (self->priv->current_time, self->priv->current_time_length1, (GDestroyNotify) g_free), NULL);
					self->priv->current_time = _tmp17_;
					self->priv->current_time_length1 = _tmp17__length1;
					self->priv->_current_time_size_ = self->priv->current_time_length1;
					result = TRUE;
					cur_time = (_vala_array_free (cur_time, cur_time_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
			}
		}
	}
	result = FALSE;
	cur_time = (_vala_array_free (cur_time, cur_time_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void g_time_local (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	localtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}


static gchar* g_time_format (struct tm *self, const gchar* format) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* buffer;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	g_return_val_if_fail (format != NULL, NULL);
	_tmp0_ = g_new0 (gchar, 64);
	buffer = _tmp0_;
	buffer_length1 = 64;
	_buffer_size_ = buffer_length1;
	_tmp1_ = buffer;
	_tmp1__length1 = buffer_length1;
	_tmp2_ = format;
	strftime (_tmp1_, _tmp1__length1, _tmp2_, &(*self));
	_tmp3_ = buffer;
	_tmp3__length1 = buffer_length1;
	_tmp4_ = g_strdup ((const gchar*) _tmp3_);
	result = _tmp4_;
	buffer = (g_free (buffer), NULL);
	return result;
}


static gchar* digital_clock_format_current_time (const gchar* format) {
	gchar* result = NULL;
	time_t _tmp0_;
	time_t cur_time_t;
	struct tm _tmp1_ = {0};
	struct tm cur_time;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (format != NULL, NULL);
	_tmp0_ = time (NULL);
	cur_time_t = _tmp0_;
	g_time_local (cur_time_t, &_tmp1_);
	cur_time = _tmp1_;
	_tmp2_ = format;
	_tmp3_ = g_time_format (&cur_time, _tmp2_);
	result = _tmp3_;
	return result;
}


static gchar** digital_clock_get_time_string (DigitalClock* self, int* result_length1) {
	gchar** result = NULL;
	gchar** _tmp0_ = NULL;
	gchar** full_date;
	gint full_date_length1;
	gint _full_date_size_;
	time_t _tmp1_;
	time_t cur_time_t;
	time_t _tmp2_;
	struct tm _tmp3_ = {0};
	struct tm cur_time;
	gboolean _tmp4_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	const gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 4 + 1);
	full_date = _tmp0_;
	full_date_length1 = 4;
	_full_date_size_ = full_date_length1;
	_tmp1_ = time (NULL);
	cur_time_t = _tmp1_;
	_tmp2_ = cur_time_t;
	g_time_local (_tmp2_, &_tmp3_);
	cur_time = _tmp3_;
	_tmp4_ = self->priv->_is_12_hour;
	if (_tmp4_) {
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		_tmp5_ = full_date;
		_tmp5__length1 = full_date_length1;
		_tmp6_ = g_time_format (&cur_time, "%I:%M");
		_g_free0 (_tmp5_[0]);
		_tmp5_[0] = _tmp6_;
		_tmp7_ = _tmp5_[0];
		_tmp8_ = full_date;
		_tmp8__length1 = full_date_length1;
		_tmp9_ = g_time_format (&cur_time, "%p");
		_g_free0 (_tmp8_[1]);
		_tmp8_[1] = _tmp9_;
		_tmp10_ = _tmp8_[1];
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp11_ = full_date;
		_tmp11__length1 = full_date_length1;
		_tmp12_ = g_time_format (&cur_time, "%H:%M");
		_g_free0 (_tmp11_[0]);
		_tmp11_[0] = _tmp12_;
		_tmp13_ = _tmp11_[0];
		_tmp14_ = full_date;
		_tmp14__length1 = full_date_length1;
		_tmp15_ = g_strdup ("");
		_g_free0 (_tmp14_[1]);
		_tmp14_[1] = _tmp15_;
		_tmp16_ = _tmp14_[1];
	}
	_tmp17_ = full_date;
	_tmp17__length1 = full_date_length1;
	_tmp18_ = g_time_format (&cur_time, "%a");
	_g_free0 (_tmp17_[2]);
	_tmp17_[2] = _tmp18_;
	_tmp19_ = _tmp17_[2];
	_tmp20_ = full_date;
	_tmp20__length1 = full_date_length1;
	_tmp21_ = _ ("%b %d");
	_tmp22_ = g_time_format (&cur_time, _tmp21_);
	_g_free0 (_tmp20_[3]);
	_tmp20_[3] = _tmp22_;
	_tmp23_ = _tmp20_[3];
	_tmp24_ = full_date;
	_tmp24__length1 = full_date_length1;
	if (result_length1) {
		*result_length1 = _tmp24__length1;
	}
	result = _tmp24_;
	return result;
}


static void digital_clock_on_clicked (DigitalClock* self) {
	AwnDialog* _tmp0_;
	GtkWidgetFlags _tmp1_ = 0;
	GtkWidgetFlags flags;
	GtkWidgetFlags _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->dialog;
	_tmp1_ = GTK_WIDGET_FLAGS ((GtkWidget*) _tmp0_);
	flags = _tmp1_ & GTK_VISIBLE;
	_tmp2_ = flags;
	if (_tmp2_ != GTK_VISIBLE) {
		time_t _tmp3_;
		time_t cur_time_t;
		time_t _tmp4_;
		struct tm _tmp5_ = {0};
		struct tm today;
		GtkCalendar* _tmp6_;
		struct tm _tmp7_;
		gint _tmp8_;
		struct tm _tmp9_;
		gint _tmp10_;
		GtkCalendar* _tmp11_;
		struct tm _tmp12_;
		gint _tmp13_;
		AwnDialog* _tmp14_;
		_tmp3_ = time (NULL);
		cur_time_t = _tmp3_;
		_tmp4_ = cur_time_t;
		g_time_local (_tmp4_, &_tmp5_);
		today = _tmp5_;
		_tmp6_ = self->priv->calendar;
		_tmp7_ = today;
		_tmp8_ = _tmp7_.tm_mon;
		_tmp9_ = today;
		_tmp10_ = _tmp9_.tm_year;
		gtk_calendar_select_month (_tmp6_, (guint) _tmp8_, (guint) (_tmp10_ + 1900));
		_tmp11_ = self->priv->calendar;
		_tmp12_ = today;
		_tmp13_ = _tmp12_.tm_mday;
		gtk_calendar_select_day (_tmp11_, (guint) _tmp13_);
		_tmp14_ = self->priv->dialog;
		gtk_widget_show_all ((GtkWidget*) _tmp14_);
	} else {
		AwnDialog* _tmp15_;
		_tmp15_ = self->priv->dialog;
		gtk_widget_hide ((GtkWidget*) _tmp15_);
	}
}


static void ___lambda3_ (DigitalClock* self, GtkMenuItem* w) {
	GtkClipboard* _tmp0_ = NULL;
	GtkClipboard* cb;
	gboolean _tmp1_;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_clipboard_get (GDK_SELECTION_CLIPBOARD);
	cb = _tmp0_;
	_tmp1_ = self->priv->_is_12_hour;
	if (_tmp1_) {
		GtkClipboard* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp2_ = cb;
		_tmp3_ = digital_clock_format_current_time ("%I:%M %p");
		_tmp4_ = _tmp3_;
		gtk_clipboard_set_text (_tmp2_, _tmp4_, -1);
		_g_free0 (_tmp4_);
	} else {
		GtkClipboard* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		_tmp5_ = cb;
		_tmp6_ = digital_clock_format_current_time ("%H:%M");
		_tmp7_ = _tmp6_;
		gtk_clipboard_set_text (_tmp5_, _tmp7_, -1);
		_g_free0 (_tmp7_);
	}
}


static void ____lambda3__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	___lambda3_ (self, _sender);
}


static void ___lambda4_ (DigitalClock* self, GtkMenuItem* w) {
	GtkClipboard* _tmp0_ = NULL;
	GtkClipboard* cb;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_clipboard_get (GDK_SELECTION_CLIPBOARD);
	cb = _tmp0_;
	_tmp1_ = digital_clock_format_current_time ("%A, %B %d %Y");
	_tmp2_ = _tmp1_;
	gtk_clipboard_set_text (cb, _tmp2_, -1);
	_g_free0 (_tmp2_);
}


static void ____lambda4__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	___lambda4_ (self, _sender);
}


static void ___lambda5_ (DigitalClock* self, GtkMenuItem* w) {
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (w != NULL);
	_tmp0_ = self->priv->_datetime_command;
	_tmp1_ = strlen (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ > 0) {
		const gchar* _tmp3_;
		_tmp3_ = self->priv->_datetime_command;
		g_spawn_command_line_async (_tmp3_, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void ____lambda5__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	___lambda5_ (self, _sender);
}


static void ___lambda6_ (DigitalClock* self, GtkMenuItem* w) {
	DigitalClockPrefs* _tmp0_;
	g_return_if_fail (w != NULL);
	_tmp0_ = self->priv->prefs;
	if (_tmp0_ == NULL) {
		DigitalClockPrefs* _tmp1_;
		DigitalClockPrefs* _tmp2_;
		GtkDialog* _tmp3_ = NULL;
		DigitalClockPrefs* _tmp4_;
		GtkDialog* _tmp5_ = NULL;
		_tmp1_ = digital_clock_prefs_new ((AwnApplet*) self);
		_g_object_unref0 (self->priv->prefs);
		self->priv->prefs = _tmp1_;
		_tmp2_ = self->priv->prefs;
		_tmp3_ = digital_clock_prefs_get_dialog (_tmp2_);
		gtk_dialog_run (_tmp3_);
		_tmp4_ = self->priv->prefs;
		_tmp5_ = digital_clock_prefs_get_dialog (_tmp4_);
		gtk_object_destroy ((GtkObject*) _tmp5_);
		_g_object_unref0 (self->priv->prefs);
		self->priv->prefs = NULL;
	} else {
		DigitalClockPrefs* _tmp6_;
		GtkDialog* _tmp7_ = NULL;
		GtkDialog* _tmp8_;
		GtkDialog* dialog;
		GtkDialog* _tmp9_;
		guint32 _tmp10_ = 0U;
		_tmp6_ = self->priv->prefs;
		_tmp7_ = digital_clock_prefs_get_dialog (_tmp6_);
		_tmp8_ = _g_object_ref0 (_tmp7_);
		dialog = _tmp8_;
		_tmp9_ = dialog;
		_tmp10_ = gtk_get_current_event_time ();
		gtk_window_present_with_time ((GtkWindow*) _tmp9_, _tmp10_);
		_g_object_unref0 (dialog);
	}
}


static void ____lambda6__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	___lambda6_ (self, _sender);
}


static void digital_clock_on_context_menu_popup (DigitalClock* self, GdkEventButton* event) {
	GtkMenu* _tmp0_;
	GtkMenu* _tmp55_;
	AwnIcon* _tmp56_ = NULL;
	GtkMenu* _tmp57_;
	GdkEventButton _tmp58_;
	guint _tmp59_;
	GdkEventButton _tmp60_;
	guint32 _tmp61_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	_tmp0_ = self->priv->_menu;
	if (_tmp0_ == NULL) {
		GtkImageMenuItem* image_item = NULL;
		GtkMenuItem* menu_item = NULL;
		GtkWidget* about_item = NULL;
		GtkWidget* _tmp1_ = NULL;
		GtkMenu* _tmp2_;
		const gchar* _tmp3_ = NULL;
		GtkImageMenuItem* _tmp4_;
		GtkImageMenuItem* _tmp5_;
		GtkImageMenuItem* _tmp6_;
		GtkImage* _tmp7_;
		GtkImage* _tmp8_;
		GtkImageMenuItem* _tmp9_;
		GtkImageMenuItem* _tmp10_;
		GtkMenu* _tmp11_;
		GtkImageMenuItem* _tmp12_;
		const gchar* _tmp13_ = NULL;
		GtkImageMenuItem* _tmp14_;
		GtkImageMenuItem* _tmp15_;
		GtkImageMenuItem* _tmp16_;
		GtkImage* _tmp17_;
		GtkImage* _tmp18_;
		GtkImageMenuItem* _tmp19_;
		GtkImageMenuItem* _tmp20_;
		GtkMenu* _tmp21_;
		GtkImageMenuItem* _tmp22_;
		const gchar* _tmp23_ = NULL;
		GtkImageMenuItem* _tmp24_;
		GtkImageMenuItem* _tmp25_;
		GtkImageMenuItem* _tmp26_;
		GtkImage* _tmp27_;
		GtkImage* _tmp28_;
		GtkImageMenuItem* _tmp29_;
		GtkImageMenuItem* _tmp30_;
		GtkMenu* _tmp31_;
		GtkImageMenuItem* _tmp32_;
		GtkSeparatorMenuItem* _tmp33_;
		GtkMenuItem* _tmp34_;
		GtkMenuItem* _tmp35_;
		GtkMenu* _tmp36_;
		GtkMenuItem* _tmp37_;
		GtkImageMenuItem* _tmp38_;
		GtkImageMenuItem* _tmp39_;
		GtkImageMenuItem* _tmp40_;
		GtkImageMenuItem* _tmp41_;
		GtkMenu* _tmp42_;
		GtkImageMenuItem* _tmp43_;
		GtkSeparatorMenuItem* _tmp44_;
		GtkMenuItem* _tmp45_;
		GtkMenuItem* separator;
		GtkMenuItem* _tmp46_;
		GtkMenu* _tmp47_;
		GtkMenuItem* _tmp48_;
		const gchar* _tmp49_ = NULL;
		GtkWidget* _tmp50_ = NULL;
		GtkWidget* _tmp51_;
		GtkWidget* _tmp52_;
		GtkMenu* _tmp53_;
		GtkWidget* _tmp54_;
		_tmp1_ = awn_applet_create_default_menu ((AwnApplet*) self);
		_tmp2_ = _g_object_ref0 (GTK_IS_MENU (_tmp1_) ? ((GtkMenu*) _tmp1_) : NULL);
		_g_object_unref0 (self->priv->_menu);
		self->priv->_menu = _tmp2_;
		_tmp3_ = _ ("Copy Time");
		_tmp4_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_label (_tmp3_);
		_tmp5_ = g_object_ref_sink (_tmp4_);
		_g_object_unref0 (image_item);
		image_item = _tmp5_;
		_tmp6_ = image_item;
		_tmp7_ = (GtkImage*) gtk_image_new_from_stock (GTK_STOCK_COPY, GTK_ICON_SIZE_MENU);
		_tmp8_ = g_object_ref_sink (_tmp7_);
		gtk_image_menu_item_set_image (_tmp6_, (GtkWidget*) _tmp8_);
		_g_object_unref0 (_tmp8_);
		_tmp9_ = image_item;
		g_signal_connect_object ((GtkMenuItem*) _tmp9_, "activate", (GCallback) ____lambda3__gtk_menu_item_activate, self, 0);
		_tmp10_ = image_item;
		gtk_widget_show ((GtkWidget*) _tmp10_);
		_tmp11_ = self->priv->_menu;
		_tmp12_ = image_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, (GtkWidget*) ((GtkMenuItem*) _tmp12_));
		_tmp13_ = _ ("Copy Date");
		_tmp14_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_label (_tmp13_);
		_tmp15_ = g_object_ref_sink (_tmp14_);
		_g_object_unref0 (image_item);
		image_item = _tmp15_;
		_tmp16_ = image_item;
		_tmp17_ = (GtkImage*) gtk_image_new_from_stock (GTK_STOCK_COPY, GTK_ICON_SIZE_MENU);
		_tmp18_ = g_object_ref_sink (_tmp17_);
		gtk_image_menu_item_set_image (_tmp16_, (GtkWidget*) _tmp18_);
		_g_object_unref0 (_tmp18_);
		_tmp19_ = image_item;
		g_signal_connect_object ((GtkMenuItem*) _tmp19_, "activate", (GCallback) ____lambda4__gtk_menu_item_activate, self, 0);
		_tmp20_ = image_item;
		gtk_widget_show ((GtkWidget*) _tmp20_);
		_tmp21_ = self->priv->_menu;
		_tmp22_ = image_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp21_, (GtkWidget*) ((GtkMenuItem*) _tmp22_));
		_tmp23_ = _ ("Adjust Date & Time");
		_tmp24_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_label (_tmp23_);
		_tmp25_ = g_object_ref_sink (_tmp24_);
		_g_object_unref0 (image_item);
		image_item = _tmp25_;
		_tmp26_ = image_item;
		_tmp27_ = (GtkImage*) gtk_image_new_from_stock (GTK_STOCK_EDIT, GTK_ICON_SIZE_MENU);
		_tmp28_ = g_object_ref_sink (_tmp27_);
		gtk_image_menu_item_set_image (_tmp26_, (GtkWidget*) _tmp28_);
		_g_object_unref0 (_tmp28_);
		_tmp29_ = image_item;
		g_signal_connect_object ((GtkMenuItem*) _tmp29_, "activate", (GCallback) ____lambda5__gtk_menu_item_activate, self, 0);
		_tmp30_ = image_item;
		gtk_widget_show ((GtkWidget*) _tmp30_);
		_tmp31_ = self->priv->_menu;
		_tmp32_ = image_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp31_, (GtkWidget*) ((GtkMenuItem*) _tmp32_));
		_tmp33_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
		_tmp34_ = (GtkMenuItem*) g_object_ref_sink (_tmp33_);
		_g_object_unref0 (menu_item);
		menu_item = _tmp34_;
		_tmp35_ = menu_item;
		gtk_widget_show ((GtkWidget*) _tmp35_);
		_tmp36_ = self->priv->_menu;
		_tmp37_ = menu_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp36_, (GtkWidget*) _tmp37_);
		_tmp38_ = (GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_PREFERENCES, NULL);
		_tmp39_ = g_object_ref_sink (_tmp38_);
		_g_object_unref0 (image_item);
		image_item = _tmp39_;
		_tmp40_ = image_item;
		g_signal_connect_object ((GtkMenuItem*) _tmp40_, "activate", (GCallback) ____lambda6__gtk_menu_item_activate, self, 0);
		_tmp41_ = image_item;
		gtk_widget_show ((GtkWidget*) _tmp41_);
		_tmp42_ = self->priv->_menu;
		_tmp43_ = image_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp42_, (GtkWidget*) ((GtkMenuItem*) _tmp43_));
		_tmp44_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
		_tmp45_ = (GtkMenuItem*) g_object_ref_sink (_tmp44_);
		separator = _tmp45_;
		_tmp46_ = separator;
		gtk_widget_show ((GtkWidget*) _tmp46_);
		_tmp47_ = self->priv->_menu;
		_tmp48_ = separator;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp47_, (GtkWidget*) _tmp48_);
		_tmp49_ = _ ("Displays digital clock.");
		_tmp50_ = awn_applet_create_about_item ((AwnApplet*) self, "Copyright © 2010 Michal Hruby", AWN_APPLET_LICENSE_GPLV2, VERSION, _tmp49_, NULL, NULL, "awn-applet-digital-clock", NULL, DIGITAL_CLOCK_authors, NULL, NULL);
		_tmp51_ = _g_object_ref0 (_tmp50_);
		_g_object_unref0 (about_item);
		about_item = _tmp51_;
		_tmp52_ = about_item;
		gtk_widget_show (_tmp52_);
		_tmp53_ = self->priv->_menu;
		_tmp54_ = about_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp53_, (GtkWidget*) (GTK_IS_MENU_ITEM (_tmp54_) ? ((GtkMenuItem*) _tmp54_) : NULL));
		_g_object_unref0 (separator);
		_g_object_unref0 (about_item);
		_g_object_unref0 (menu_item);
		_g_object_unref0 (image_item);
	}
	_tmp55_ = self->priv->_menu;
	gtk_menu_set_screen (_tmp55_, NULL);
	_tmp56_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp57_ = self->priv->_menu;
	_tmp58_ = *event;
	_tmp59_ = _tmp58_.button;
	_tmp60_ = *event;
	_tmp61_ = _tmp60_.time;
	awn_icon_popup_gtk_menu (_tmp56_, (GtkWidget*) _tmp57_, _tmp59_, _tmp61_);
}


gboolean digital_clock_get_is_12_hour (DigitalClock* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_12_hour;
	result = _tmp0_;
	return result;
}


void digital_clock_set_is_12_hour (DigitalClock* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_is_12_hour = _tmp0_;
	g_object_notify ((GObject *) self, "is-12-hour");
}


gboolean digital_clock_get_show_date (DigitalClock* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_show_date;
	result = _tmp0_;
	return result;
}


void digital_clock_set_show_date (DigitalClock* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_show_date = _tmp0_;
	g_object_notify ((GObject *) self, "show-date");
}


gboolean digital_clock_get_date_before_time (DigitalClock* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_date_before_time;
	result = _tmp0_;
	return result;
}


void digital_clock_set_date_before_time (DigitalClock* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_date_before_time = _tmp0_;
	g_object_notify ((GObject *) self, "date-before-time");
}


const gchar* digital_clock_get_calendar_command (DigitalClock* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_calendar_command;
	result = _tmp0_;
	return result;
}


void digital_clock_set_calendar_command (DigitalClock* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_calendar_command);
	self->priv->_calendar_command = _tmp1_;
	g_object_notify ((GObject *) self, "calendar-command");
}


const gchar* digital_clock_get_datetime_command (DigitalClock* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_datetime_command;
	result = _tmp0_;
	return result;
}


void digital_clock_set_datetime_command (DigitalClock* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_datetime_command);
	self->priv->_datetime_command = _tmp1_;
	g_object_notify ((GObject *) self, "datetime-command");
}


static void digital_clock_class_init (DigitalClockClass * klass) {
	digital_clock_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DigitalClockPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_digital_clock_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_digital_clock_set_property;
	G_OBJECT_CLASS (klass)->finalize = digital_clock_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIGITAL_CLOCK_IS_12_HOUR, g_param_spec_boolean ("is-12-hour", "is-12-hour", "is-12-hour", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIGITAL_CLOCK_SHOW_DATE, g_param_spec_boolean ("show-date", "show-date", "show-date", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIGITAL_CLOCK_DATE_BEFORE_TIME, g_param_spec_boolean ("date-before-time", "date-before-time", "date-before-time", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIGITAL_CLOCK_CALENDAR_COMMAND, g_param_spec_string ("calendar-command", "calendar-command", "calendar-command", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIGITAL_CLOCK_DATETIME_COMMAND, g_param_spec_string ("datetime-command", "datetime-command", "datetime-command", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void digital_clock_instance_init (DigitalClock * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = DIGITAL_CLOCK_GET_PRIVATE (self);
	self->priv->current_time = NULL;
	self->priv->prefs = NULL;
	self->priv->_show_date = TRUE;
	_tmp0_ = g_strdup (DIGITAL_CLOCK_EVOLUTION_COMMAND);
	self->priv->_calendar_command = _tmp0_;
	_tmp1_ = g_strdup (DIGITAL_CLOCK_TIME_ADMIN_COMMAND);
	self->priv->_datetime_command = _tmp1_;
}


static void digital_clock_finalize (GObject* obj) {
	DigitalClock * self;
	self = DIGITAL_CLOCK (obj);
	_g_object_unref0 (self->priv->_menu);
	_g_object_unref0 (self->priv->dialog);
	_g_object_unref0 (self->priv->calendar);
	_g_object_unref0 (self->priv->time_overlay);
	_g_object_unref0 (self->priv->am_pm_overlay);
	_g_object_unref0 (self->priv->day_overlay);
	_g_object_unref0 (self->priv->date_overlay);
	_g_object_unref0 (self->priv->client);
	self->priv->current_time = (_vala_array_free (self->priv->current_time, self->priv->current_time_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (self->priv->prefs);
	_g_free0 (self->priv->_calendar_command);
	_g_free0 (self->priv->_datetime_command);
	G_OBJECT_CLASS (digital_clock_parent_class)->finalize (obj);
}


GType digital_clock_get_type (void) {
	static volatile gsize digital_clock_type_id__volatile = 0;
	if (g_once_init_enter (&digital_clock_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DigitalClockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) digital_clock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DigitalClock), 0, (GInstanceInitFunc) digital_clock_instance_init, NULL };
		GType digital_clock_type_id;
		digital_clock_type_id = g_type_register_static (AWN_TYPE_APPLET_SIMPLE, "DigitalClock", &g_define_type_info, 0);
		g_once_init_leave (&digital_clock_type_id__volatile, digital_clock_type_id);
	}
	return digital_clock_type_id__volatile;
}


static void _vala_digital_clock_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DigitalClock * self;
	self = DIGITAL_CLOCK (object);
	switch (property_id) {
		case DIGITAL_CLOCK_IS_12_HOUR:
		g_value_set_boolean (value, digital_clock_get_is_12_hour (self));
		break;
		case DIGITAL_CLOCK_SHOW_DATE:
		g_value_set_boolean (value, digital_clock_get_show_date (self));
		break;
		case DIGITAL_CLOCK_DATE_BEFORE_TIME:
		g_value_set_boolean (value, digital_clock_get_date_before_time (self));
		break;
		case DIGITAL_CLOCK_CALENDAR_COMMAND:
		g_value_set_string (value, digital_clock_get_calendar_command (self));
		break;
		case DIGITAL_CLOCK_DATETIME_COMMAND:
		g_value_set_string (value, digital_clock_get_datetime_command (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_digital_clock_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DigitalClock * self;
	self = DIGITAL_CLOCK (object);
	switch (property_id) {
		case DIGITAL_CLOCK_IS_12_HOUR:
		digital_clock_set_is_12_hour (self, g_value_get_boolean (value));
		break;
		case DIGITAL_CLOCK_SHOW_DATE:
		digital_clock_set_show_date (self, g_value_get_boolean (value));
		break;
		case DIGITAL_CLOCK_DATE_BEFORE_TIME:
		digital_clock_set_date_before_time (self, g_value_get_boolean (value));
		break;
		case DIGITAL_CLOCK_CALENDAR_COMMAND:
		digital_clock_set_calendar_command (self, g_value_get_string (value));
		break;
		case DIGITAL_CLOCK_DATETIME_COMMAND:
		digital_clock_set_datetime_command (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	AwnApplet* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	DigitalClock* _tmp3_;
	AwnApplet* _tmp4_;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	_tmp3_ = digital_clock_new (_tmp0_, _tmp1_, _tmp2_);
	_tmp4_ = (AwnApplet*) g_object_ref_sink (_tmp3_);
	result = _tmp4_;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



