/* notification-area.c generated by valac 0.13.4, the Vala compiler
 * generated from notification-area.vala, do not modify */

/*
 * Copyright (C) 2009 Michal Hruby <michal.mhr@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Michal Hruby <michal.mhr@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <eggtraymanager.h>
#include <libawn/libawn.h>
#include <egg-tray-child.h>
#include <gtk/gtk.h>
#include <libdesktop-agnostic/config.h>
#include <libdesktop-agnostic/desktop-agnostic.h>
#include <gdk/gdk.h>
#include <libawn/awn-utils.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n.h>
#include <config.h>


#define TYPE_NOTIFICATION_AREA (notification_area_get_type ())
#define NOTIFICATION_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_AREA, NotificationArea))
#define NOTIFICATION_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_AREA, NotificationAreaClass))
#define IS_NOTIFICATION_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_AREA))
#define IS_NOTIFICATION_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_AREA))
#define NOTIFICATION_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_AREA, NotificationAreaClass))

typedef struct _NotificationArea NotificationArea;
typedef struct _NotificationAreaClass NotificationAreaClass;
typedef struct _NotificationAreaPrivate NotificationAreaPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

#define TYPE_NOTIFICATION_AREA_PREFS (notification_area_prefs_get_type ())
#define NOTIFICATION_AREA_PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_AREA_PREFS, NotificationAreaPrefs))
#define NOTIFICATION_AREA_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_AREA_PREFS, NotificationAreaPrefsClass))
#define IS_NOTIFICATION_AREA_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_AREA_PREFS))
#define IS_NOTIFICATION_AREA_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_AREA_PREFS))
#define NOTIFICATION_AREA_PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_AREA_PREFS, NotificationAreaPrefsClass))

typedef struct _NotificationAreaPrefs NotificationAreaPrefs;
typedef struct _NotificationAreaPrefsClass NotificationAreaPrefsClass;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NotificationArea {
	GObject parent_instance;
	NotificationAreaPrivate * priv;
};

struct _NotificationAreaClass {
	GObjectClass parent_class;
};

struct _NotificationAreaPrivate {
	EggTrayManager* manager;
	AwnApplet* applet;
	GList* tray_icons;
	gint max_rows;
	gint max_cols;
	gint redraw_timer;
	GQuark addition_quark;
	GQuark deletion_quark;
	GtkEventBox* eb;
	AwnAlignment* align;
	GtkAlignment* inner_align;
	GtkEventBox* icon_painter;
	GtkTable* table;
	DesktopAgnosticConfigClient* client;
	gint _icon_size;
	gint _extra_offset;
	DesktopAgnosticColor* _background_color;
	DesktopAgnosticColor* _border_color;
};


extern gboolean gpm_workaround_done;
gboolean gpm_workaround_done = FALSE;
static gpointer notification_area_parent_class = NULL;
static NotificationAreaPrefs* notification_area_prefs_window;
static NotificationAreaPrefs* notification_area_prefs_window = NULL;

GType notification_area_get_type (void) G_GNUC_CONST;
#define NOTIFICATION_AREA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTIFICATION_AREA, NotificationAreaPrivate))
enum  {
	NOTIFICATION_AREA_DUMMY_PROPERTY,
	NOTIFICATION_AREA_ICONS_PER_CELL,
	NOTIFICATION_AREA_ICON_SIZE,
	NOTIFICATION_AREA_EXTRA_OFFSET,
	NOTIFICATION_AREA_BACKGROUND_COLOR,
	NOTIFICATION_AREA_BORDER_COLOR
};
GType notification_area_prefs_get_type (void) G_GNUC_CONST;
#define NOTIFICATION_AREA_BORDER 2
NotificationArea* notification_area_new (AwnApplet* applet);
NotificationArea* notification_area_construct (GType object_type, AwnApplet* applet);
static void notification_area_on_icon_added (NotificationArea* self, GtkWidget* widget);
static void _notification_area_on_icon_added_egg_tray_manager_tray_icon_added (EggTrayManager* _sender, GtkWidget* object, gpointer self);
static void notification_area_on_icon_removed (NotificationArea* self, GtkWidget* widget);
static void _notification_area_on_icon_removed_egg_tray_manager_tray_icon_removed (EggTrayManager* _sender, GtkWidget* object, gpointer self);
static void __lambda9_ (NotificationArea* self, GtkPositionType new_pos);
static void notification_area_update_icon_sizes (NotificationArea* self);
static void notification_area_table_refresh (NotificationArea* self);
static void ___lambda9__awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self);
static void __lambda10_ (NotificationArea* self, gint new_size);
static void ___lambda10__awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self);
static gboolean notification_area_on_applet_expose (NotificationArea* self, GdkEventExpose* event);
static gboolean _notification_area_on_applet_expose_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self);
static gboolean notification_area_button_press (NotificationArea* self, GdkEventButton* event);
static gboolean _notification_area_button_press_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean notification_area_on_painter_expose (NotificationArea* self, GdkEvent* event, GtkBin* eb);
static void notification_area_tray_icon_expose (GtkWidget* widget, cairo_t* cr);
NotificationAreaPrefs* notification_area_prefs_new (AwnApplet* applet);
NotificationAreaPrefs* notification_area_prefs_construct (GType object_type, AwnApplet* applet);
GtkDialog* notification_area_prefs_get_dialog (NotificationAreaPrefs* self);
static gint notification_area_get_tray_icon_size (NotificationArea* self);
gboolean workaround_gpm_bug (void);
static gboolean _workaround_gpm_bug_gsource_func (gpointer self);
static gboolean notification_area_redraw_scheduler (NotificationArea* self);
static gboolean _notification_area_redraw_scheduler_gsource_func (gpointer self);
gboolean notification_area_on_visibility_change (NotificationArea* self, GdkEvent* event, GtkWidget* applet);
gint notification_area_get_icons_per_cell (NotificationArea* self);
void notification_area_set_icons_per_cell (NotificationArea* self, gint value);
gint notification_area_get_icon_size (NotificationArea* self);
void notification_area_set_icon_size (NotificationArea* self, gint value);
gint notification_area_get_extra_offset (NotificationArea* self);
void notification_area_set_extra_offset (NotificationArea* self, gint value);
DesktopAgnosticColor* notification_area_get_background_color (NotificationArea* self);
void notification_area_set_background_color (NotificationArea* self, DesktopAgnosticColor* value);
DesktopAgnosticColor* notification_area_get_border_color (NotificationArea* self);
void notification_area_set_border_color (NotificationArea* self, DesktopAgnosticColor* value);
static void notification_area_finalize (GObject* obj);
static void _vala_notification_area_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_notification_area_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _notification_area_on_icon_added_egg_tray_manager_tray_icon_added (EggTrayManager* _sender, GtkWidget* object, gpointer self) {
	notification_area_on_icon_added (self, object);
}


static void _notification_area_on_icon_removed_egg_tray_manager_tray_icon_removed (EggTrayManager* _sender, GtkWidget* object, gpointer self) {
	notification_area_on_icon_removed (self, object);
}


static void __lambda9_ (NotificationArea* self, GtkPositionType new_pos) {
	notification_area_update_icon_sizes (self);
	notification_area_table_refresh (self);
}


static void ___lambda9__awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self) {
	__lambda9_ (self, position);
}


static void __lambda10_ (NotificationArea* self, gint new_size) {
	notification_area_update_icon_sizes (self);
}


static void ___lambda10__awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self) {
	__lambda10_ (self, size);
}


static gboolean _notification_area_on_applet_expose_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self) {
	gboolean result;
	result = notification_area_on_applet_expose (self, event);
	return result;
}


static gboolean _notification_area_button_press_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = notification_area_button_press (self, event);
	return result;
}


NotificationArea* notification_area_construct (GType object_type, AwnApplet* applet) {
	NotificationArea * self = NULL;
	AwnApplet* _tmp0_;
	AwnApplet* _tmp1_;
	EggTrayManager* _tmp2_;
	GQuark _tmp3_ = 0U;
	GQuark _tmp4_ = 0U;
	AwnApplet* _tmp5_;
	GdkScreen* _tmp6_ = NULL;
	GdkScreen* screen;
	EggTrayManager* _tmp7_;
	GdkScreen* _tmp8_;
	gboolean _tmp9_ = FALSE;
	EggTrayManager* _tmp10_;
	EggTrayManager* _tmp11_;
	AwnApplet* _tmp12_;
	AwnApplet* _tmp13_;
	GtkEventBox* _tmp14_;
	GtkEventBox* _tmp15_;
	GtkEventBox* _tmp16_;
	AwnApplet* _tmp17_;
	AwnAlignment* _tmp18_;
	AwnAlignment* _tmp19_;
	AwnAlignment* _tmp20_;
	GtkAlignment* _tmp21_;
	GtkAlignment* _tmp22_;
	GtkAlignment* _tmp23_;
	GtkEventBox* _tmp24_;
	GtkEventBox* _tmp25_;
	GtkEventBox* _tmp26_;
	GtkTable* _tmp27_;
	GtkTable* _tmp28_;
	GtkTable* _tmp29_;
	GtkTable* _tmp30_;
	AwnApplet* _tmp31_;
	GtkEventBox* _tmp32_;
	GtkEventBox* _tmp33_;
	AwnAlignment* _tmp34_;
	AwnAlignment* _tmp35_;
	GtkAlignment* _tmp36_;
	GtkAlignment* _tmp37_;
	GtkEventBox* _tmp38_;
	GdkScreen* _tmp39_;
	GdkColormap* _tmp40_ = NULL;
	GtkEventBox* _tmp47_;
	GtkTable* _tmp48_;
	GtkEventBox* _tmp49_;
	GtkEventBox* _tmp50_;
	GtkEventBox* _tmp51_;
	GtkEventBox* _tmp52_;
	GtkEventBox* _tmp53_;
	AwnApplet* _tmp54_;
	DesktopAgnosticConfigClient* _tmp55_ = NULL;
	DesktopAgnosticConfigClient* _tmp56_;
	DesktopAgnosticConfigClient* _tmp57_;
	DesktopAgnosticConfigClient* _tmp58_;
	DesktopAgnosticConfigClient* _tmp59_;
	DesktopAgnosticConfigClient* _tmp60_;
	DesktopAgnosticConfigClient* _tmp61_;
	DesktopAgnosticConfigClient* _tmp62_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (applet != NULL, NULL);
	self = (NotificationArea*) g_object_new (object_type, NULL);
	_tmp0_ = applet;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->applet);
	self->priv->applet = _tmp1_;
	_tmp2_ = egg_tray_manager_new ();
	_g_object_unref0 (self->priv->manager);
	self->priv->manager = _tmp2_;
	_g_list_free0 (self->priv->tray_icons);
	self->priv->tray_icons = NULL;
	self->priv->max_rows = 2;
	self->priv->max_cols = 2;
	self->priv->redraw_timer = 0;
	_tmp3_ = g_quark_from_string ("na-tray-icon-added");
	self->priv->addition_quark = _tmp3_;
	_tmp4_ = g_quark_from_string ("na-tray-icon-deleted");
	self->priv->deletion_quark = _tmp4_;
	_tmp5_ = applet;
	_tmp6_ = gtk_window_get_screen ((GtkWindow*) _tmp5_);
	screen = _tmp6_;
	_tmp7_ = self->priv->manager;
	_tmp8_ = screen;
	_tmp9_ = egg_tray_manager_manage_screen (_tmp7_, _tmp8_);
	if (_tmp9_ == FALSE) {
		g_error ("notification-area.vala:147: Unable to manage the screen!");
	}
	_tmp10_ = self->priv->manager;
	g_signal_connect_object (_tmp10_, "tray-icon-added", (GCallback) _notification_area_on_icon_added_egg_tray_manager_tray_icon_added, self, 0);
	_tmp11_ = self->priv->manager;
	g_signal_connect_object (_tmp11_, "tray-icon-removed", (GCallback) _notification_area_on_icon_removed_egg_tray_manager_tray_icon_removed, self, 0);
	_tmp12_ = self->priv->applet;
	g_signal_connect_object (_tmp12_, "position-changed", (GCallback) ___lambda9__awn_applet_position_changed, self, 0);
	_tmp13_ = self->priv->applet;
	g_signal_connect_object (_tmp13_, "size-changed", (GCallback) ___lambda10__awn_applet_size_changed, self, 0);
	_tmp14_ = (GtkEventBox*) gtk_event_box_new ();
	_tmp15_ = g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->eb);
	self->priv->eb = _tmp15_;
	_tmp16_ = self->priv->eb;
	awn_utils_ensure_transparent_bg ((GtkWidget*) _tmp16_);
	_tmp17_ = applet;
	_tmp18_ = (AwnAlignment*) awn_alignment_new_for_applet (_tmp17_);
	_tmp19_ = g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->align);
	self->priv->align = _tmp19_;
	_tmp20_ = self->priv->align;
	awn_alignment_set_offset_modifier (_tmp20_, -NOTIFICATION_AREA_BORDER);
	_tmp21_ = (GtkAlignment*) gtk_alignment_new (0.f, 0.f, 1.f, 1.f);
	_tmp22_ = g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->inner_align);
	self->priv->inner_align = _tmp22_;
	_tmp23_ = self->priv->inner_align;
	gtk_alignment_set_padding (_tmp23_, (guint) NOTIFICATION_AREA_BORDER, (guint) NOTIFICATION_AREA_BORDER, (guint) NOTIFICATION_AREA_BORDER, (guint) NOTIFICATION_AREA_BORDER);
	_tmp24_ = (GtkEventBox*) gtk_event_box_new ();
	_tmp25_ = g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->icon_painter);
	self->priv->icon_painter = _tmp25_;
	_tmp26_ = self->priv->icon_painter;
	awn_utils_ensure_transparent_bg ((GtkWidget*) _tmp26_);
	_tmp27_ = (GtkTable*) gtk_table_new ((guint) 1, (guint) 1, FALSE);
	_tmp28_ = g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->table);
	self->priv->table = _tmp28_;
	_tmp29_ = self->priv->table;
	gtk_table_set_row_spacings (_tmp29_, (guint) 1);
	_tmp30_ = self->priv->table;
	gtk_table_set_col_spacings (_tmp30_, (guint) 1);
	_tmp31_ = applet;
	_tmp32_ = self->priv->eb;
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = self->priv->eb;
	_tmp34_ = self->priv->align;
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
	_tmp35_ = self->priv->align;
	_tmp36_ = self->priv->inner_align;
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->inner_align;
	_tmp38_ = self->priv->icon_painter;
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
	_tmp39_ = screen;
	_tmp40_ = gdk_screen_get_rgba_colormap (_tmp39_);
	if (_tmp40_ != NULL) {
		GtkEventBox* _tmp41_;
		GdkScreen* _tmp42_;
		GdkColormap* _tmp43_ = NULL;
		GtkEventBox* _tmp44_;
		GdkScreen* _tmp45_;
		GdkColormap* _tmp46_ = NULL;
		_tmp41_ = self->priv->eb;
		_tmp42_ = screen;
		_tmp43_ = gdk_screen_get_rgba_colormap (_tmp42_);
		gtk_widget_set_colormap ((GtkWidget*) _tmp41_, _tmp43_);
		_tmp44_ = self->priv->icon_painter;
		_tmp45_ = screen;
		_tmp46_ = gdk_screen_get_rgba_colormap (_tmp45_);
		gtk_widget_set_colormap ((GtkWidget*) _tmp44_, _tmp46_);
	}
	_tmp47_ = self->priv->icon_painter;
	_tmp48_ = self->priv->table;
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = self->priv->eb;
	g_signal_connect_object ((GtkWidget*) _tmp49_, "expose-event", (GCallback) _notification_area_on_applet_expose_gtk_widget_expose_event, self, 0);
	_tmp50_ = self->priv->eb;
	g_signal_connect_object ((GtkWidget*) _tmp50_, "button-press-event", (GCallback) _notification_area_button_press_gtk_widget_button_press_event, self, 0);
	_tmp51_ = self->priv->icon_painter;
	g_signal_connect_swapped (_tmp51_, "expose-event", (GCallback) notification_area_on_painter_expose, self);
	_tmp52_ = self->priv->icon_painter;
	_tmp53_ = self->priv->eb;
	g_signal_connect_swapped (_tmp52_, "size-allocate", (GCallback) gtk_widget_queue_draw, _tmp53_);
	_tmp54_ = applet;
	_tmp55_ = awn_config_get_default_for_applet (_tmp54_, &_inner_error_);
	_tmp56_ = _tmp55_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp57_ = _g_object_ref0 (_tmp56_);
	_g_object_unref0 (self->priv->client);
	self->priv->client = _tmp57_;
	_tmp58_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp58_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "icons_per_cell", (GObject*) self, "icons-per-cell", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp59_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp59_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "icon_size", (GObject*) self, "icon-size", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp60_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp60_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "extra_offset", (GObject*) self, "extra-offset", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp61_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp61_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "background_color", (GObject*) self, "background-color", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp62_ = self->priv->client;
	desktop_agnostic_config_client_bind (_tmp62_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "border_color", (GObject*) self, "border-color", TRUE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


NotificationArea* notification_area_new (AwnApplet* applet) {
	return notification_area_construct (TYPE_NOTIFICATION_AREA, applet);
}


static void notification_area_tray_icon_expose (GtkWidget* widget, cairo_t* cr) {
	GtkWidget* _tmp0_;
	EggTrayChild* child;
	EggTrayChild* _tmp1_;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (widget != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = widget;
	child = EGG_TRAY_CHILD (_tmp0_);
	_tmp1_ = child;
	_tmp2_ = egg_tray_child_is_alpha_capable (_tmp1_);
	if (_tmp2_) {
		cairo_t* _tmp3_;
		cairo_t* _tmp4_;
		GtkWidget* _tmp5_;
		GtkAllocation _tmp6_;
		GdkRectangle _tmp7_;
		cairo_t* _tmp8_;
		gdouble x1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y1 = 0.0;
		gdouble y2 = 0.0;
		cairo_t* _tmp9_;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gboolean _tmp14_ = FALSE;
		gdouble _tmp15_;
		gdouble _tmp16_;
		gboolean _tmp19_;
		EggTrayChild* _tmp21_;
		guint _tmp22_;
		cairo_t* _tmp48_;
		gint _tmp49_ = 0;
		_tmp3_ = cr;
		cairo_save (_tmp3_);
		_tmp4_ = cr;
		_tmp5_ = widget;
		_tmp6_ = _tmp5_->allocation;
		_tmp7_ = (GdkRectangle) _tmp6_;
		gdk_cairo_rectangle (_tmp4_, &_tmp7_);
		_tmp8_ = cr;
		cairo_clip (_tmp8_);
		_tmp9_ = cr;
		cairo_clip_extents (_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
		x1 = _tmp10_;
		y1 = _tmp11_;
		x2 = _tmp12_;
		y2 = _tmp13_;
		_tmp15_ = x2;
		_tmp16_ = x1;
		if ((_tmp15_ - _tmp16_) <= 0.0) {
			_tmp14_ = TRUE;
		} else {
			gdouble _tmp17_;
			gdouble _tmp18_;
			_tmp17_ = y2;
			_tmp18_ = y1;
			_tmp14_ = (_tmp17_ - _tmp18_) <= 0.0;
		}
		_tmp19_ = _tmp14_;
		if (_tmp19_) {
			cairo_t* _tmp20_;
			_tmp20_ = cr;
			cairo_restore (_tmp20_);
			return;
		}
		gdk_error_trap_push ();
		_tmp21_ = child;
		_tmp22_ = _tmp21_->fake_transparency;
		if (_tmp22_ != ((guint) 0)) {
			EggTrayChild* _tmp23_;
			cairo_surface_t* _tmp24_ = NULL;
			cairo_surface_t* img_srfc;
			cairo_surface_t* _tmp25_;
			_tmp23_ = child;
			_tmp24_ = egg_tray_child_get_image_surface (_tmp23_);
			img_srfc = _tmp24_;
			_tmp25_ = img_srfc;
			if (_tmp25_ != NULL) {
				cairo_t* _tmp26_;
				cairo_t* _tmp27_;
				cairo_surface_t* _tmp28_;
				EggTrayChild* _tmp29_;
				GtkAllocation _tmp30_;
				gint _tmp31_;
				EggTrayChild* _tmp32_;
				GtkAllocation _tmp33_;
				gint _tmp34_;
				cairo_t* _tmp35_;
				cairo_t* _tmp36_;
				cairo_surface_t* _tmp37_ = NULL;
				_tmp26_ = cr;
				cairo_set_operator (_tmp26_, CAIRO_OPERATOR_OVER);
				_tmp27_ = cr;
				_tmp28_ = img_srfc;
				_tmp29_ = child;
				_tmp30_ = ((GtkWidget*) _tmp29_)->allocation;
				_tmp31_ = _tmp30_.x;
				_tmp32_ = child;
				_tmp33_ = ((GtkWidget*) _tmp32_)->allocation;
				_tmp34_ = _tmp33_.y;
				cairo_set_source_surface (_tmp27_, _tmp28_, (gdouble) _tmp31_, (gdouble) _tmp34_);
				_tmp35_ = cr;
				cairo_paint (_tmp35_);
				_tmp36_ = cr;
				_tmp37_ = cairo_get_target (_tmp36_);
				cairo_surface_flush (_tmp37_);
			}
			_cairo_surface_destroy0 (img_srfc);
		} else {
			cairo_t* _tmp38_;
			GtkWidget* _tmp39_;
			GdkWindow* _tmp40_;
			GtkWidget* _tmp41_;
			GtkAllocation _tmp42_;
			gint _tmp43_;
			GtkWidget* _tmp44_;
			GtkAllocation _tmp45_;
			gint _tmp46_;
			cairo_t* _tmp47_;
			_tmp38_ = cr;
			_tmp39_ = widget;
			_tmp40_ = _tmp39_->window;
			_tmp41_ = widget;
			_tmp42_ = _tmp41_->allocation;
			_tmp43_ = _tmp42_.x;
			_tmp44_ = widget;
			_tmp45_ = _tmp44_->allocation;
			_tmp46_ = _tmp45_.y;
			gdk_cairo_set_source_pixmap (_tmp38_, (GdkPixmap*) _tmp40_, (gdouble) _tmp43_, (gdouble) _tmp46_);
			_tmp47_ = cr;
			cairo_paint (_tmp47_);
		}
		_tmp48_ = cr;
		cairo_restore (_tmp48_);
		gdk_flush ();
		_tmp49_ = gdk_error_trap_pop ();
		if (_tmp49_ != 0) {
		}
	}
}


static gboolean notification_area_on_painter_expose (NotificationArea* self, GdkEvent* event, GtkBin* eb) {
	gboolean result = FALSE;
	GtkBin* _tmp0_;
	GdkWindow* _tmp1_;
	cairo_t* _tmp2_ = NULL;
	cairo_t* cr;
	cairo_t* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEventExpose _tmp5_;
	GdkRegion* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	DesktopAgnosticColor* _tmp11_;
	GtkBin* _tmp27_;
	GtkWidget* _tmp28_ = NULL;
	GtkWidget* child;
	GtkWidget* _tmp29_;
	GtkWidget* _tmp35_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (eb != NULL, FALSE);
	_tmp0_ = eb;
	_tmp1_ = ((GtkWidget*) _tmp0_)->window;
	_tmp2_ = gdk_cairo_create ((GdkDrawable*) _tmp1_);
	cr = _tmp2_;
	_tmp3_ = cr;
	_tmp4_ = event;
	_tmp5_ = _tmp4_->expose;
	_tmp6_ = _tmp5_.region;
	gdk_cairo_region (_tmp3_, _tmp6_);
	_tmp7_ = cr;
	cairo_clip (_tmp7_);
	_tmp8_ = cr;
	cairo_set_operator (_tmp8_, CAIRO_OPERATOR_CLEAR);
	_tmp9_ = cr;
	cairo_paint (_tmp9_);
	_tmp10_ = cr;
	cairo_set_operator (_tmp10_, CAIRO_OPERATOR_OVER);
	_tmp11_ = self->priv->_background_color;
	if (_tmp11_ != NULL) {
		cairo_t* _tmp12_;
		DesktopAgnosticColor* _tmp13_;
		cairo_t* _tmp14_;
		_tmp12_ = cr;
		_tmp13_ = self->priv->_background_color;
		awn_cairo_set_source_color (_tmp12_, _tmp13_);
		_tmp14_ = cr;
		cairo_paint (_tmp14_);
	} else {
		GtkBin* _tmp15_;
		GtkStyle* _tmp16_;
		GtkStyle* _tmp17_;
		GdkColor* _tmp18_;
		gint _tmp18__length1;
		GdkColor _tmp19_;
		DesktopAgnosticColor* _tmp20_;
		DesktopAgnosticColor* da_color;
		GtkBin* _tmp21_;
		gboolean _tmp22_ = FALSE;
		cairo_t* _tmp24_;
		DesktopAgnosticColor* _tmp25_;
		cairo_t* _tmp26_;
		_tmp15_ = eb;
		_tmp16_ = gtk_widget_get_style ((GtkWidget*) _tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_->bg;
		_tmp18__length1 = -1;
		_tmp19_ = _tmp18_[GTK_STATE_ACTIVE];
		_tmp20_ = desktop_agnostic_color_new (&_tmp19_, (gushort) 65535);
		da_color = _tmp20_;
		_tmp21_ = eb;
		_tmp22_ = gtk_widget_is_composited ((GtkWidget*) _tmp21_);
		if (_tmp22_) {
			DesktopAgnosticColor* _tmp23_;
			_tmp23_ = da_color;
			desktop_agnostic_color_set_alpha (_tmp23_, (guint) (65535 / 5));
		}
		_tmp24_ = cr;
		_tmp25_ = da_color;
		awn_cairo_set_source_color (_tmp24_, _tmp25_);
		_tmp26_ = cr;
		cairo_paint (_tmp26_);
		_g_object_unref0 (da_color);
	}
	_tmp27_ = eb;
	_tmp28_ = gtk_bin_get_child (_tmp27_);
	child = _tmp28_;
	_tmp29_ = child;
	if (_tmp29_ != NULL) {
		GtkWidget* _tmp30_;
		GtkContainer* container;
		GtkContainer* _tmp31_;
		GList* _tmp32_ = NULL;
		_tmp30_ = child;
		container = GTK_CONTAINER (_tmp30_);
		_tmp31_ = container;
		_tmp32_ = gtk_container_get_children (_tmp31_);
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
			w_collection = _tmp32_;
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
				GtkWidget* w = NULL;
				w = (GtkWidget*) w_it->data;
				{
					GtkWidget* _tmp33_;
					cairo_t* _tmp34_;
					_tmp33_ = w;
					_tmp34_ = cr;
					notification_area_tray_icon_expose (_tmp33_, _tmp34_);
				}
			}
			_g_list_free0 (w_collection);
		}
	}
	_cairo_destroy0 (cr);
	cr = NULL;
	_tmp35_ = child;
	if (_tmp35_ != NULL) {
		GtkBin* _tmp36_;
		GtkWidget* _tmp37_;
		GdkEvent* _tmp38_;
		GdkEventExpose _tmp39_;
		_tmp36_ = eb;
		_tmp37_ = child;
		_tmp38_ = event;
		_tmp39_ = _tmp38_->expose;
		gtk_container_propagate_expose ((GtkContainer*) _tmp36_, _tmp37_, &_tmp39_);
	}
	result = TRUE;
	_cairo_destroy0 (cr);
	return result;
}


static gboolean notification_area_on_applet_expose (NotificationArea* self, GdkEventExpose* event) {
	gboolean result = FALSE;
	GtkEventBox* _tmp0_;
	GdkWindow* _tmp1_;
	cairo_t* _tmp2_ = NULL;
	cairo_t* cr;
	cairo_t* _tmp3_;
	GtkAlignment* _tmp4_;
	GtkAllocation _tmp5_;
	gint _tmp6_;
	gint x;
	GtkAlignment* _tmp7_;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	gint y;
	GtkAlignment* _tmp10_;
	GtkAllocation _tmp11_;
	gint _tmp12_;
	gint w;
	GtkAlignment* _tmp13_;
	GtkAllocation _tmp14_;
	gint _tmp15_;
	gint h;
	cairo_t* _tmp16_;
	GdkEventExpose _tmp17_;
	GdkRegion* _tmp18_;
	cairo_t* _tmp19_;
	cairo_t* _tmp20_;
	DesktopAgnosticColor* _tmp21_;
	cairo_t* _tmp35_;
	cairo_t* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	DesktopAgnosticColor* _tmp41_;
	DesktopAgnosticColor* _tmp44_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->eb;
	_tmp1_ = ((GtkWidget*) _tmp0_)->window;
	_tmp2_ = gdk_cairo_create ((GdkDrawable*) _tmp1_);
	cr = _tmp2_;
	_tmp3_ = cr;
	if (_tmp3_ == NULL) {
		result = FALSE;
		_cairo_destroy0 (cr);
		return result;
	}
	_tmp4_ = self->priv->inner_align;
	_tmp5_ = ((GtkWidget*) _tmp4_)->allocation;
	_tmp6_ = _tmp5_.x;
	x = _tmp6_;
	_tmp7_ = self->priv->inner_align;
	_tmp8_ = ((GtkWidget*) _tmp7_)->allocation;
	_tmp9_ = _tmp8_.y;
	y = _tmp9_;
	_tmp10_ = self->priv->inner_align;
	_tmp11_ = ((GtkWidget*) _tmp10_)->allocation;
	_tmp12_ = _tmp11_.width;
	w = _tmp12_;
	_tmp13_ = self->priv->inner_align;
	_tmp14_ = ((GtkWidget*) _tmp13_)->allocation;
	_tmp15_ = _tmp14_.height;
	h = _tmp15_;
	_tmp16_ = cr;
	_tmp17_ = *event;
	_tmp18_ = _tmp17_.region;
	gdk_cairo_region (_tmp16_, _tmp18_);
	_tmp19_ = cr;
	cairo_clip (_tmp19_);
	_tmp20_ = cr;
	cairo_set_operator (_tmp20_, CAIRO_OPERATOR_OVER);
	_tmp21_ = self->priv->_background_color;
	if (_tmp21_ != NULL) {
		cairo_t* _tmp22_;
		DesktopAgnosticColor* _tmp23_;
		_tmp22_ = cr;
		_tmp23_ = self->priv->_background_color;
		awn_cairo_set_source_color (_tmp22_, _tmp23_);
	} else {
		GtkEventBox* _tmp24_;
		GtkStyle* _tmp25_;
		GtkStyle* _tmp26_;
		GdkColor* _tmp27_;
		gint _tmp27__length1;
		GdkColor _tmp28_;
		DesktopAgnosticColor* _tmp29_;
		DesktopAgnosticColor* da_color;
		AwnApplet* _tmp30_;
		gboolean _tmp31_ = FALSE;
		cairo_t* _tmp33_;
		DesktopAgnosticColor* _tmp34_;
		_tmp24_ = self->priv->eb;
		_tmp25_ = gtk_widget_get_style ((GtkWidget*) _tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = _tmp26_->bg;
		_tmp27__length1 = -1;
		_tmp28_ = _tmp27_[GTK_STATE_ACTIVE];
		_tmp29_ = desktop_agnostic_color_new (&_tmp28_, (gushort) 65535);
		da_color = _tmp29_;
		_tmp30_ = self->priv->applet;
		_tmp31_ = gtk_widget_is_composited ((GtkWidget*) _tmp30_);
		if (_tmp31_) {
			DesktopAgnosticColor* _tmp32_;
			_tmp32_ = da_color;
			desktop_agnostic_color_set_alpha (_tmp32_, (guint) (65535 / 5));
		}
		_tmp33_ = cr;
		_tmp34_ = da_color;
		awn_cairo_set_source_color (_tmp33_, _tmp34_);
		_g_object_unref0 (da_color);
	}
	_tmp35_ = cr;
	cairo_set_line_width (_tmp35_, 1.0);
	_tmp36_ = cr;
	_tmp37_ = x;
	_tmp38_ = y;
	_tmp39_ = w;
	_tmp40_ = h;
	awn_cairo_rounded_rect (_tmp36_, _tmp37_ + 0.5, _tmp38_ + 0.5, _tmp39_ - 1.0, _tmp40_ - 1.0, 2.0 * NOTIFICATION_AREA_BORDER, ROUND_ALL);
	_tmp41_ = self->priv->_border_color;
	if (_tmp41_ == NULL) {
		cairo_t* _tmp42_;
		_tmp42_ = cr;
		cairo_fill (_tmp42_);
	} else {
		cairo_t* _tmp43_;
		_tmp43_ = cr;
		cairo_fill_preserve (_tmp43_);
	}
	_tmp44_ = self->priv->_border_color;
	if (_tmp44_ != NULL) {
		cairo_t* _tmp45_;
		DesktopAgnosticColor* _tmp46_;
		cairo_t* _tmp47_;
		cairo_t* _tmp48_;
		cairo_t* _tmp49_;
		cairo_t* _tmp50_;
		cairo_t* _tmp51_;
		cairo_t* _tmp52_;
		_tmp45_ = cr;
		_tmp46_ = self->priv->_border_color;
		awn_cairo_set_source_color (_tmp45_, _tmp46_);
		_tmp47_ = cr;
		cairo_set_operator (_tmp47_, CAIRO_OPERATOR_DEST_OUT);
		_tmp48_ = cr;
		cairo_set_line_width (_tmp48_, 1.5);
		_tmp49_ = cr;
		cairo_stroke_preserve (_tmp49_);
		_tmp50_ = cr;
		cairo_set_operator (_tmp50_, CAIRO_OPERATOR_OVER);
		_tmp51_ = cr;
		cairo_set_line_width (_tmp51_, 1.0);
		_tmp52_ = cr;
		cairo_stroke (_tmp52_);
	}
	result = TRUE;
	_cairo_destroy0 (cr);
	return result;
}


static gboolean notification_area_button_press (NotificationArea* self, GdkEventButton* event) {
	gboolean result = FALSE;
	GdkEventButton _tmp0_;
	guint _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = *event;
	_tmp1_ = _tmp0_.button;
	if (_tmp1_ == ((guint) 3)) {
		NotificationAreaPrefs* _tmp2_;
		_tmp2_ = notification_area_prefs_window;
		if (_tmp2_ == NULL) {
			AwnApplet* _tmp3_;
			NotificationAreaPrefs* _tmp4_;
			NotificationAreaPrefs* _tmp5_;
			GtkDialog* _tmp6_ = NULL;
			GtkDialog* dialog;
			GtkDialog* _tmp7_;
			GtkDialog* _tmp8_;
			_tmp3_ = self->priv->applet;
			_tmp4_ = notification_area_prefs_new (_tmp3_);
			_g_object_unref0 (notification_area_prefs_window);
			notification_area_prefs_window = _tmp4_;
			_tmp5_ = notification_area_prefs_window;
			_tmp6_ = notification_area_prefs_get_dialog (_tmp5_);
			dialog = _tmp6_;
			_tmp7_ = dialog;
			gtk_dialog_run (_tmp7_);
			_tmp8_ = dialog;
			gtk_object_destroy ((GtkObject*) _tmp8_);
			_g_object_unref0 (notification_area_prefs_window);
			notification_area_prefs_window = NULL;
		} else {
			NotificationAreaPrefs* _tmp9_;
			GtkDialog* _tmp10_ = NULL;
			GtkDialog* _tmp11_;
			GtkDialog* dialog;
			GtkDialog* _tmp12_;
			GdkEventButton _tmp13_;
			guint32 _tmp14_;
			_tmp9_ = notification_area_prefs_window;
			_tmp10_ = notification_area_prefs_get_dialog (_tmp9_);
			_tmp11_ = _g_object_ref0 (_tmp10_);
			dialog = _tmp11_;
			_tmp12_ = dialog;
			_tmp13_ = *event;
			_tmp14_ = _tmp13_.time;
			gtk_window_present_with_time ((GtkWindow*) _tmp12_, _tmp14_);
			_g_object_unref0 (dialog);
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static void notification_area_table_refresh (NotificationArea* self) {
	gboolean _tmp0_ = FALSE;
	AwnApplet* _tmp1_;
	gboolean _tmp3_;
	gint row;
	gint col;
	AwnApplet* _tmp4_;
	GtkPositionType _tmp5_ = 0;
	GtkPositionType position;
	GtkTable* _tmp6_;
	GList* _tmp7_ = NULL;
	GList* _tmp32_;
	GList* _tmp58_;
	guint _tmp59_ = 0U;
	guint elements;
	guint num_rows = 0U;
	guint num_cols = 0U;
	gint _tmp60_;
	guint rows;
	gint _tmp61_;
	guint cols;
	gboolean _tmp62_ = FALSE;
	GtkPositionType _tmp63_;
	gboolean _tmp65_;
	guint _tmp88_ = 0U;
	guint _tmp89_;
	guint _tmp91_ = 0U;
	guint _tmp92_;
	GtkTable* _tmp94_;
	guint _tmp95_;
	guint _tmp96_;
	GtkTable* _tmp97_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->applet;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GtkTable* _tmp2_;
		_tmp2_ = self->priv->table;
		_tmp0_ = _tmp2_ == NULL;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		return;
	}
	row = 0;
	col = 0;
	_tmp4_ = self->priv->applet;
	_tmp5_ = awn_applet_get_pos_type (_tmp4_);
	position = _tmp5_;
	_tmp6_ = self->priv->table;
	_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
	{
		GList* icon_collection = NULL;
		GList* icon_it = NULL;
		icon_collection = _tmp7_;
		for (icon_it = icon_collection; icon_it != NULL; icon_it = icon_it->next) {
			GtkWidget* icon = NULL;
			icon = (GtkWidget*) icon_it->data;
			{
				GtkWidget* _tmp8_;
				GQuark _tmp9_;
				gconstpointer _tmp10_ = NULL;
				void* del;
				void* _tmp11_;
				_tmp8_ = icon;
				_tmp9_ = self->priv->deletion_quark;
				_tmp10_ = g_object_get_qdata ((GObject*) _tmp8_, _tmp9_);
				del = _tmp10_;
				_tmp11_ = del;
				if (_tmp11_ != NULL) {
					GtkTable* _tmp12_;
					GtkWidget* _tmp13_;
					_tmp12_ = self->priv->table;
					_tmp13_ = icon;
					gtk_container_remove ((GtkContainer*) _tmp12_, _tmp13_);
				} else {
					GtkTable* _tmp14_;
					GtkWidget* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					gboolean _tmp20_ = FALSE;
					GtkPositionType _tmp21_;
					gboolean _tmp23_;
					_tmp14_ = self->priv->table;
					_tmp15_ = icon;
					_tmp16_ = col;
					_tmp17_ = col;
					_tmp18_ = row;
					_tmp19_ = row;
					gtk_container_child_set ((GtkContainer*) _tmp14_, _tmp15_, "left-attach", _tmp16_, "right-attach", _tmp17_ + 1, "top-attach", _tmp18_, "bottom-attach", _tmp19_ + 1, NULL);
					_tmp21_ = position;
					if (_tmp21_ == GTK_POS_TOP) {
						_tmp20_ = TRUE;
					} else {
						GtkPositionType _tmp22_;
						_tmp22_ = position;
						_tmp20_ = _tmp22_ == GTK_POS_BOTTOM;
					}
					_tmp23_ = _tmp20_;
					if (_tmp23_) {
						gint _tmp24_;
						gint _tmp25_;
						gint _tmp26_;
						_tmp24_ = row;
						row = _tmp24_ + 1;
						_tmp25_ = row;
						_tmp26_ = self->priv->max_rows;
						if (_tmp25_ == _tmp26_) {
							gint _tmp27_;
							row = 0;
							_tmp27_ = col;
							col = _tmp27_ + 1;
						}
					} else {
						gint _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
						_tmp28_ = col;
						col = _tmp28_ + 1;
						_tmp29_ = col;
						_tmp30_ = self->priv->max_cols;
						if (_tmp29_ == _tmp30_) {
							gint _tmp31_;
							col = 0;
							_tmp31_ = row;
							row = _tmp31_ + 1;
						}
					}
				}
			}
		}
		_g_list_free0 (icon_collection);
	}
	_tmp32_ = self->priv->tray_icons;
	{
		GList* icon_collection = NULL;
		GList* icon_it = NULL;
		icon_collection = _tmp32_;
		for (icon_it = icon_collection; icon_it != NULL; icon_it = icon_it->next) {
			EggTrayChild* icon = NULL;
			icon = (EggTrayChild*) icon_it->data;
			{
				EggTrayChild* _tmp33_;
				GQuark _tmp34_;
				gconstpointer _tmp35_ = NULL;
				void* added;
				void* _tmp36_;
				EggTrayChild* _tmp37_;
				GQuark _tmp38_;
				void* _tmp39_ = NULL;
				GtkTable* _tmp40_;
				EggTrayChild* _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				gboolean _tmp46_ = FALSE;
				GtkPositionType _tmp47_;
				gboolean _tmp49_;
				_tmp33_ = icon;
				_tmp34_ = self->priv->addition_quark;
				_tmp35_ = g_object_get_qdata ((GObject*) _tmp33_, _tmp34_);
				added = _tmp35_;
				_tmp36_ = added;
				if (_tmp36_ == NULL) {
					continue;
				}
				_tmp37_ = icon;
				_tmp38_ = self->priv->addition_quark;
				_tmp39_ = GINT_TO_POINTER (0);
				g_object_set_qdata_full ((GObject*) _tmp37_, _tmp38_, _tmp39_, NULL);
				_tmp40_ = self->priv->table;
				_tmp41_ = icon;
				_tmp42_ = col;
				_tmp43_ = col;
				_tmp44_ = row;
				_tmp45_ = row;
				gtk_table_attach_defaults (_tmp40_, (GtkWidget*) _tmp41_, (guint) _tmp42_, (guint) (_tmp43_ + 1), (guint) _tmp44_, (guint) (_tmp45_ + 1));
				_tmp47_ = position;
				if (_tmp47_ == GTK_POS_TOP) {
					_tmp46_ = TRUE;
				} else {
					GtkPositionType _tmp48_;
					_tmp48_ = position;
					_tmp46_ = _tmp48_ == GTK_POS_BOTTOM;
				}
				_tmp49_ = _tmp46_;
				if (_tmp49_) {
					gint _tmp50_;
					gint _tmp51_;
					gint _tmp52_;
					_tmp50_ = row;
					row = _tmp50_ + 1;
					_tmp51_ = row;
					_tmp52_ = self->priv->max_rows;
					if (_tmp51_ == _tmp52_) {
						gint _tmp53_;
						row = 0;
						_tmp53_ = col;
						col = _tmp53_ + 1;
					}
				} else {
					gint _tmp54_;
					gint _tmp55_;
					gint _tmp56_;
					_tmp54_ = col;
					col = _tmp54_ + 1;
					_tmp55_ = col;
					_tmp56_ = self->priv->max_cols;
					if (_tmp55_ == _tmp56_) {
						gint _tmp57_;
						col = 0;
						_tmp57_ = row;
						row = _tmp57_ + 1;
					}
				}
			}
		}
	}
	_tmp58_ = self->priv->tray_icons;
	_tmp59_ = g_list_length (_tmp58_);
	elements = _tmp59_;
	_tmp60_ = self->priv->max_rows;
	rows = (guint) _tmp60_;
	_tmp61_ = self->priv->max_cols;
	cols = (guint) _tmp61_;
	_tmp63_ = position;
	if (_tmp63_ == GTK_POS_TOP) {
		_tmp62_ = TRUE;
	} else {
		GtkPositionType _tmp64_;
		_tmp64_ = position;
		_tmp62_ = _tmp64_ == GTK_POS_BOTTOM;
	}
	_tmp65_ = _tmp62_;
	if (_tmp65_) {
		GtkTable* _tmp66_;
		guint _tmp67_ = 0U;
		guint _tmp68_;
		guint _tmp69_ = 0U;
		guint _tmp70_;
		gint _tmp71_;
		guint _tmp76_;
		_tmp66_ = self->priv->table;
		g_object_get (_tmp66_, "n-columns", &_tmp67_, NULL);
		_tmp68_ = _tmp67_;
		num_cols = _tmp68_;
		_tmp70_ = elements;
		_tmp71_ = self->priv->max_rows;
		if ((_tmp70_ % _tmp71_) == ((guint) 0)) {
			guint _tmp72_;
			gint _tmp73_;
			_tmp72_ = num_cols;
			_tmp73_ = self->priv->max_rows;
			_tmp69_ = _tmp72_ / _tmp73_;
		} else {
			guint _tmp74_;
			gint _tmp75_;
			_tmp74_ = num_cols;
			_tmp75_ = self->priv->max_rows;
			_tmp69_ = (_tmp74_ / _tmp75_) + 1;
		}
		_tmp76_ = _tmp69_;
		cols = _tmp76_;
	} else {
		GtkTable* _tmp77_;
		guint _tmp78_ = 0U;
		guint _tmp79_;
		guint _tmp80_ = 0U;
		guint _tmp81_;
		gint _tmp82_;
		guint _tmp87_;
		_tmp77_ = self->priv->table;
		g_object_get (_tmp77_, "n-rows", &_tmp78_, NULL);
		_tmp79_ = _tmp78_;
		num_rows = _tmp79_;
		_tmp81_ = elements;
		_tmp82_ = self->priv->max_cols;
		if ((_tmp81_ % _tmp82_) == ((guint) 0)) {
			guint _tmp83_;
			gint _tmp84_;
			_tmp83_ = num_rows;
			_tmp84_ = self->priv->max_cols;
			_tmp80_ = _tmp83_ / _tmp84_;
		} else {
			guint _tmp85_;
			gint _tmp86_;
			_tmp85_ = num_rows;
			_tmp86_ = self->priv->max_cols;
			_tmp80_ = (_tmp85_ / _tmp86_) + 1;
		}
		_tmp87_ = _tmp80_;
		rows = _tmp87_;
	}
	_tmp89_ = rows;
	if (_tmp89_ > ((guint) 0)) {
		guint _tmp90_;
		_tmp90_ = rows;
		_tmp88_ = _tmp90_;
	} else {
		_tmp88_ = (guint) 1;
	}
	_tmp92_ = cols;
	if (_tmp92_ > ((guint) 0)) {
		guint _tmp93_;
		_tmp93_ = cols;
		_tmp91_ = _tmp93_;
	} else {
		_tmp91_ = (guint) 1;
	}
	_tmp94_ = self->priv->table;
	_tmp95_ = _tmp88_;
	_tmp96_ = _tmp91_;
	gtk_table_resize (_tmp94_, _tmp95_, _tmp96_);
	_tmp97_ = self->priv->table;
	gtk_widget_queue_draw ((GtkWidget*) _tmp97_);
}


static gint notification_area_get_tray_icon_size (NotificationArea* self) {
	gint result = 0;
	AwnApplet* _tmp0_;
	gint _tmp1_ = 0;
	gint size;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint icon_size;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp28_ = 0;
	gint _tmp29_;
	gint _tmp31_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->applet;
	_tmp1_ = awn_applet_get_size (_tmp0_);
	size = (gint) _tmp1_;
	_tmp2_ = size;
	_tmp3_ = self->priv->max_rows;
	_tmp4_ = self->priv->max_rows;
	icon_size = (_tmp2_ - (_tmp3_ - 1)) / _tmp4_;
	_tmp5_ = icon_size;
	_tmp6_ = self->priv->_icon_size;
	icon_size = (_tmp5_ * _tmp6_) / 100;
	_tmp7_ = self->priv->max_rows;
	if (_tmp7_ == 2) {
		gint _tmp8_;
		AwnApplet* _tmp10_;
		GtkPositionType _tmp11_ = 0;
		GtkPositionType position;
		gint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_ = 0;
		gint extra_space;
		gboolean _tmp16_ = FALSE;
		GtkPositionType _tmp17_;
		gboolean _tmp19_;
		_tmp8_ = icon_size;
		if ((_tmp8_ % 2) != 0) {
			gint _tmp9_;
			_tmp9_ = icon_size;
			icon_size = _tmp9_ - 1;
		}
		_tmp10_ = self->priv->applet;
		_tmp11_ = awn_applet_get_pos_type (_tmp10_);
		position = _tmp11_;
		_tmp12_ = size;
		_tmp13_ = icon_size;
		_tmp14_ = self->priv->max_rows;
		_tmp15_ = MAX (_tmp12_ - (_tmp13_ * _tmp14_), 1);
		extra_space = _tmp15_;
		_tmp17_ = position;
		if (_tmp17_ == GTK_POS_TOP) {
			_tmp16_ = TRUE;
		} else {
			GtkPositionType _tmp18_;
			_tmp18_ = position;
			_tmp16_ = _tmp18_ == GTK_POS_BOTTOM;
		}
		_tmp19_ = _tmp16_;
		if (_tmp19_) {
			GtkTable* _tmp20_;
			gint _tmp21_;
			GtkTable* _tmp22_;
			_tmp20_ = self->priv->table;
			_tmp21_ = extra_space;
			gtk_table_set_row_spacings (_tmp20_, (guint) _tmp21_);
			_tmp22_ = self->priv->table;
			gtk_table_set_col_spacings (_tmp22_, (guint) 1);
		} else {
			GtkTable* _tmp23_;
			GtkTable* _tmp24_;
			gint _tmp25_;
			_tmp23_ = self->priv->table;
			gtk_table_set_row_spacings (_tmp23_, (guint) 1);
			_tmp24_ = self->priv->table;
			_tmp25_ = extra_space;
			gtk_table_set_col_spacings (_tmp24_, (guint) _tmp25_);
		}
	} else {
		GtkTable* _tmp26_;
		GtkTable* _tmp27_;
		_tmp26_ = self->priv->table;
		gtk_table_set_row_spacings (_tmp26_, (guint) 1);
		_tmp27_ = self->priv->table;
		gtk_table_set_col_spacings (_tmp27_, (guint) 1);
	}
	_tmp29_ = icon_size;
	if (_tmp29_ < 1) {
		_tmp28_ = 1;
	} else {
		gint _tmp30_;
		_tmp30_ = icon_size;
		_tmp28_ = _tmp30_;
	}
	_tmp31_ = _tmp28_;
	result = _tmp31_;
	return result;
}


static void notification_area_update_icon_sizes (NotificationArea* self) {
	gint _tmp0_ = 0;
	gint icon_size;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = notification_area_get_tray_icon_size (self);
	icon_size = _tmp0_;
	_tmp1_ = self->priv->tray_icons;
	{
		GList* icon_collection = NULL;
		GList* icon_it = NULL;
		icon_collection = _tmp1_;
		for (icon_it = icon_collection; icon_it != NULL; icon_it = icon_it->next) {
			EggTrayChild* icon = NULL;
			icon = (EggTrayChild*) icon_it->data;
			{
				EggTrayChild* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				_tmp2_ = icon;
				_tmp3_ = icon_size;
				_tmp4_ = icon_size;
				gtk_widget_set_size_request ((GtkWidget*) _tmp2_, _tmp3_, _tmp4_);
			}
		}
	}
}


static gboolean _workaround_gpm_bug_gsource_func (gpointer self) {
	gboolean result;
	result = workaround_gpm_bug ();
	return result;
}


static void notification_area_on_icon_added (NotificationArea* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
	EggTrayChild* icon;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp6_;
	EggTrayChild* _tmp7_;
	GQuark _tmp8_;
	void* _tmp9_ = NULL;
	EggTrayChild* _tmp10_;
	GQuark _tmp11_;
	void* _tmp12_ = NULL;
	EggTrayChild* _tmp13_;
	gint _tmp14_ = 0;
	gint icon_size;
	EggTrayChild* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = widget;
	icon = EGG_TRAY_CHILD (_tmp0_);
	_tmp2_ = gpm_workaround_done;
	if (!_tmp2_) {
		EggTrayChild* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		_tmp3_ = icon;
		_tmp4_ = egg_tray_child_get_title (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp1_ = g_strcmp0 (_tmp5_, "gnome-power-manager") == 0;
		_g_free0 (_tmp5_);
	} else {
		_tmp1_ = FALSE;
	}
	_tmp6_ = _tmp1_;
	if (_tmp6_) {
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 2000, _workaround_gpm_bug_gsource_func, NULL, NULL);
		gpm_workaround_done = TRUE;
	}
	_tmp7_ = icon;
	_tmp8_ = self->priv->addition_quark;
	_tmp9_ = GINT_TO_POINTER (1);
	g_object_set_qdata_full ((GObject*) _tmp7_, _tmp8_, _tmp9_, NULL);
	_tmp10_ = icon;
	_tmp11_ = self->priv->deletion_quark;
	_tmp12_ = GINT_TO_POINTER (0);
	g_object_set_qdata_full ((GObject*) _tmp10_, _tmp11_, _tmp12_, NULL);
	_tmp13_ = icon;
	self->priv->tray_icons = g_list_append (self->priv->tray_icons, _tmp13_);
	_tmp14_ = notification_area_get_tray_icon_size (self);
	icon_size = _tmp14_;
	_tmp15_ = icon;
	gtk_widget_set_size_request ((GtkWidget*) _tmp15_, icon_size, icon_size);
	notification_area_table_refresh (self);
}


static void notification_area_on_icon_removed (NotificationArea* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
	EggTrayChild* icon;
	GQuark _tmp1_;
	void* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = widget;
	icon = EGG_TRAY_CHILD (_tmp0_);
	_tmp1_ = self->priv->deletion_quark;
	_tmp2_ = GINT_TO_POINTER (1);
	g_object_set_qdata_full ((GObject*) icon, _tmp1_, _tmp2_, NULL);
	self->priv->tray_icons = g_list_remove (self->priv->tray_icons, icon);
	notification_area_table_refresh (self);
}


static gboolean _notification_area_redraw_scheduler_gsource_func (gpointer self) {
	gboolean result;
	result = notification_area_redraw_scheduler (self);
	return result;
}


static gboolean notification_area_redraw_scheduler (NotificationArea* self) {
	gboolean result = FALSE;
	GtkEventBox* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->eb;
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->redraw_timer;
	switch (_tmp1_) {
		case 50:
		{
			self->priv->redraw_timer = 150;
			break;
		}
		case 150:
		{
			self->priv->redraw_timer = 350;
			break;
		}
		case 350:
		{
			self->priv->redraw_timer = 850;
			break;
		}
		default:
		{
			self->priv->redraw_timer = 0;
			break;
		}
	}
	_tmp2_ = self->priv->redraw_timer;
	if (_tmp2_ != 0) {
		gint _tmp3_;
		_tmp3_ = self->priv->redraw_timer;
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp3_, _notification_area_redraw_scheduler_gsource_func, g_object_ref (self), g_object_unref);
	}
	result = FALSE;
	return result;
}


gboolean notification_area_on_visibility_change (NotificationArea* self, GdkEvent* event, GtkWidget* applet) {
	gboolean result = FALSE;
	GdkEvent* _tmp0_;
	GdkEventVisibility _tmp1_;
	GdkVisibilityState _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (applet != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->visibility;
	_tmp2_ = _tmp1_.state;
	if (_tmp2_ == GDK_VISIBILITY_UNOBSCURED) {
		gboolean _tmp3_ = FALSE;
		GtkWidget* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp7_;
		_tmp4_ = applet;
		_tmp5_ = gtk_widget_is_composited (_tmp4_);
		if (_tmp5_) {
			gint _tmp6_;
			_tmp6_ = self->priv->redraw_timer;
			_tmp3_ = _tmp6_ == 0;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp7_ = _tmp3_;
		if (_tmp7_) {
			gint _tmp8_;
			self->priv->redraw_timer = 50;
			_tmp8_ = self->priv->redraw_timer;
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp8_, _notification_area_redraw_scheduler_gsource_func, g_object_ref (self), g_object_unref);
		}
	}
	result = FALSE;
	return result;
}


gint notification_area_get_icons_per_cell (NotificationArea* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->max_rows;
	result = _tmp0_;
	return result;
}


void notification_area_set_icons_per_cell (NotificationArea* self, gint value) {
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->max_rows = _tmp0_;
	_tmp1_ = value;
	self->priv->max_cols = _tmp1_;
	notification_area_update_icon_sizes (self);
	notification_area_table_refresh (self);
	g_object_notify ((GObject *) self, "icons-per-cell");
}


gint notification_area_get_icon_size (NotificationArea* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_icon_size;
	result = _tmp0_;
	return result;
}


void notification_area_set_icon_size (NotificationArea* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_icon_size = _tmp0_;
	notification_area_update_icon_sizes (self);
	g_object_notify ((GObject *) self, "icon-size");
}


gint notification_area_get_extra_offset (NotificationArea* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_extra_offset;
	result = _tmp0_;
	return result;
}


void notification_area_set_extra_offset (NotificationArea* self, gint value) {
	gint _tmp0_;
	AwnAlignment* _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_extra_offset = _tmp0_;
	_tmp1_ = self->priv->align;
	_tmp2_ = self->priv->_extra_offset;
	awn_alignment_set_offset_modifier (_tmp1_, _tmp2_ - NOTIFICATION_AREA_BORDER);
	g_object_notify ((GObject *) self, "extra-offset");
}


DesktopAgnosticColor* notification_area_get_background_color (NotificationArea* self) {
	DesktopAgnosticColor* result;
	DesktopAgnosticColor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_background_color;
	result = _tmp0_;
	return result;
}


void notification_area_set_background_color (NotificationArea* self, DesktopAgnosticColor* value) {
	DesktopAgnosticColor* _tmp0_;
	DesktopAgnosticColor* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkEventBox* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_background_color);
	self->priv->_background_color = _tmp1_;
	_tmp2_ = self->priv->eb;
	gtk_widget_queue_draw ((GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->icon_painter;
	gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
	g_object_notify ((GObject *) self, "background-color");
}


DesktopAgnosticColor* notification_area_get_border_color (NotificationArea* self) {
	DesktopAgnosticColor* result;
	DesktopAgnosticColor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_border_color;
	result = _tmp0_;
	return result;
}


void notification_area_set_border_color (NotificationArea* self, DesktopAgnosticColor* value) {
	DesktopAgnosticColor* _tmp0_;
	DesktopAgnosticColor* _tmp1_;
	GtkEventBox* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_border_color);
	self->priv->_border_color = _tmp1_;
	_tmp2_ = self->priv->eb;
	gtk_widget_queue_draw ((GtkWidget*) _tmp2_);
	g_object_notify ((GObject *) self, "border-color");
}


static void notification_area_class_init (NotificationAreaClass * klass) {
	notification_area_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NotificationAreaPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_notification_area_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_notification_area_set_property;
	G_OBJECT_CLASS (klass)->finalize = notification_area_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATION_AREA_ICONS_PER_CELL, g_param_spec_int ("icons-per-cell", "icons-per-cell", "icons-per-cell", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATION_AREA_ICON_SIZE, g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATION_AREA_EXTRA_OFFSET, g_param_spec_int ("extra-offset", "extra-offset", "extra-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATION_AREA_BACKGROUND_COLOR, g_param_spec_object ("background-color", "Background color", "Background color", DESKTOP_AGNOSTIC_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATION_AREA_BORDER_COLOR, g_param_spec_object ("border-color", "Border color", "Border color", DESKTOP_AGNOSTIC_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void notification_area_instance_init (NotificationArea * self) {
	self->priv = NOTIFICATION_AREA_GET_PRIVATE (self);
}


static void notification_area_finalize (GObject* obj) {
	NotificationArea * self;
	self = NOTIFICATION_AREA (obj);
	_g_object_unref0 (self->priv->manager);
	_g_object_unref0 (self->priv->applet);
	_g_list_free0 (self->priv->tray_icons);
	_g_object_unref0 (self->priv->eb);
	_g_object_unref0 (self->priv->align);
	_g_object_unref0 (self->priv->inner_align);
	_g_object_unref0 (self->priv->icon_painter);
	_g_object_unref0 (self->priv->table);
	_g_object_unref0 (self->priv->client);
	_g_object_unref0 (self->priv->_background_color);
	_g_object_unref0 (self->priv->_border_color);
	G_OBJECT_CLASS (notification_area_parent_class)->finalize (obj);
}


GType notification_area_get_type (void) {
	static volatile gsize notification_area_type_id__volatile = 0;
	if (g_once_init_enter (&notification_area_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotificationAreaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_area_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationArea), 0, (GInstanceInitFunc) notification_area_instance_init, NULL };
		GType notification_area_type_id;
		notification_area_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationArea", &g_define_type_info, 0);
		g_once_init_leave (&notification_area_type_id__volatile, notification_area_type_id);
	}
	return notification_area_type_id__volatile;
}


static void _vala_notification_area_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NotificationArea * self;
	self = NOTIFICATION_AREA (object);
	switch (property_id) {
		case NOTIFICATION_AREA_ICONS_PER_CELL:
		g_value_set_int (value, notification_area_get_icons_per_cell (self));
		break;
		case NOTIFICATION_AREA_ICON_SIZE:
		g_value_set_int (value, notification_area_get_icon_size (self));
		break;
		case NOTIFICATION_AREA_EXTRA_OFFSET:
		g_value_set_int (value, notification_area_get_extra_offset (self));
		break;
		case NOTIFICATION_AREA_BACKGROUND_COLOR:
		g_value_set_object (value, notification_area_get_background_color (self));
		break;
		case NOTIFICATION_AREA_BORDER_COLOR:
		g_value_set_object (value, notification_area_get_border_color (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_notification_area_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NotificationArea * self;
	self = NOTIFICATION_AREA (object);
	switch (property_id) {
		case NOTIFICATION_AREA_ICONS_PER_CELL:
		notification_area_set_icons_per_cell (self, g_value_get_int (value));
		break;
		case NOTIFICATION_AREA_ICON_SIZE:
		notification_area_set_icon_size (self, g_value_get_int (value));
		break;
		case NOTIFICATION_AREA_EXTRA_OFFSET:
		notification_area_set_extra_offset (self, g_value_get_int (value));
		break;
		case NOTIFICATION_AREA_BACKGROUND_COLOR:
		notification_area_set_background_color (self, g_value_get_object (value));
		break;
		case NOTIFICATION_AREA_BORDER_COLOR:
		notification_area_set_border_color (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


gboolean workaround_gpm_bug (void) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* command;
	GError * _inner_error_ = NULL;
	_tmp0_ = g_strdup ("python -c \"" "import gconf;" "c = gconf.Client();" "key = '/apps/gnome-power-manager/ui/icon_policy';" "pol = c.get_string(key);" "c.set_string(key, 'always');" "c.set_string(key, pol);" "\"");
	command = _tmp0_;
	g_spawn_command_line_async (command, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_free0 (command);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	_g_free0 (command);
	return result;
}


AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	AwnApplet* result = NULL;
	GdkScreen* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	AwnApplet* _tmp10_;
	AwnApplet* _tmp11_;
	AwnApplet* applet;
	NotificationArea* _tmp12_;
	NotificationArea* na;
	GObject* _tmp13_ = NULL;
	GObject* _tmp14_;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = gdk_screen_get_default ();
	_tmp1_ = egg_tray_manager_check_running (_tmp0_);
	if (_tmp1_) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gchar* msg;
		GtkMessageDialog* _tmp4_;
		GtkMessageDialog* _tmp5_;
		GtkMessageDialog* d;
		const gchar* _tmp6_ = NULL;
		_tmp2_ = _ ("There is already another notification area running on this screen!");
		_tmp3_ = g_strdup (_tmp2_);
		msg = _tmp3_;
		_tmp4_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", msg);
		_tmp5_ = g_object_ref_sink (_tmp4_);
		d = _tmp5_;
		_tmp6_ = _ ("Please remove the existing notification area and then restart the appl" \
"et.");
		gtk_message_dialog_format_secondary_text (d, "%s", _tmp6_);
		gtk_dialog_run ((GtkDialog*) d);
		g_error ("notification-area.vala:644: %s", msg);
		result = NULL;
		_g_object_unref0 (d);
		_g_free0 (msg);
		return result;
	}
	_tmp7_ = canonical_name;
	_tmp8_ = uid;
	_tmp9_ = panel_id;
	_tmp10_ = awn_applet_new (_tmp7_, _tmp8_, _tmp9_);
	_tmp11_ = g_object_ref_sink (_tmp10_);
	applet = _tmp11_;
	_tmp12_ = notification_area_new (applet);
	na = _tmp12_;
	_tmp13_ = g_object_ref ((GObject*) na);
	_tmp14_ = _g_object_ref0 (_tmp13_);
	g_object_set_data_full ((GObject*) applet, "notification-area", _tmp14_, g_object_unref);
	gtk_widget_add_events ((GtkWidget*) applet, (gint) GDK_VISIBILITY_NOTIFY_MASK);
	g_signal_connect_swapped (applet, "visibility-notify-event", (GCallback) notification_area_on_visibility_change, na);
	result = applet;
	_g_object_unref0 (na);
	return result;
}



