/* applet.c generated by valac 0.13.4, the Vala compiler
 * generated from applet.vala, do not modify */

/*
 * Show/hide desktop applet written in Vala.
 *
 * Copyright (C) 2009 Mark Lee <avant-wn@lazymalevolence.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Mark Lee <avant-wn@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libawn/libawn.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <libwnck/libwnck.h>
#include <glib/gi18n.h>
#include <gdk/gdk.h>
#include <config.h>
#include <locale.h>


#define TYPE_SHOW_DESKTOP (show_desktop_get_type ())
#define SHOW_DESKTOP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHOW_DESKTOP, ShowDesktop))
#define SHOW_DESKTOP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHOW_DESKTOP, ShowDesktopClass))
#define IS_SHOW_DESKTOP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHOW_DESKTOP))
#define IS_SHOW_DESKTOP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHOW_DESKTOP))
#define SHOW_DESKTOP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHOW_DESKTOP, ShowDesktopClass))

typedef struct _ShowDesktop ShowDesktop;
typedef struct _ShowDesktopClass ShowDesktopClass;
typedef struct _ShowDesktopPrivate ShowDesktopPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ShowDesktop {
	AwnAppletSimple parent_instance;
	ShowDesktopPrivate * priv;
};

struct _ShowDesktopClass {
	AwnAppletSimpleClass parent_class;
};

struct _ShowDesktopPrivate {
	GtkMenu* _menu;
};


static gpointer show_desktop_parent_class = NULL;

GType show_desktop_get_type (void) G_GNUC_CONST;
#define SHOW_DESKTOP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SHOW_DESKTOP, ShowDesktopPrivate))
enum  {
	SHOW_DESKTOP_DUMMY_PROPERTY
};
ShowDesktop* show_desktop_new (const gchar* canonical_name, const gchar* uid, gint panel_id);
ShowDesktop* show_desktop_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id);
static void show_desktop_on_clicked (ShowDesktop* self);
static void _show_desktop_on_clicked_awn_applet_simple_clicked (AwnAppletSimple* _sender, gpointer self);
static void show_desktop_on_context_menu_popup (ShowDesktop* self, GdkEventButton* event);
static void _show_desktop_on_context_menu_popup_awn_applet_simple_context_menu_popup (AwnAppletSimple* _sender, GdkEventButton* event, gpointer self);
static void show_desktop_on_show_desktop_changed (ShowDesktop* self, WnckScreen* screen);
static void _show_desktop_on_show_desktop_changed_wnck_screen_showing_desktop_changed (WnckScreen* _sender, gpointer self);
static gboolean show_desktop_on_map_event (ShowDesktop* self, GdkEvent* event);
static gboolean _show_desktop_on_map_event_gtk_widget_map_event (GtkWidget* _sender, GdkEvent* event, gpointer self);
static void show_desktop_finalize (GObject* obj);
AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id);

static const gchar* SHOW_DESKTOP_authors[1] = {"Mark Lee <avant-wn@lazymalevolence.com>"};

static void _show_desktop_on_clicked_awn_applet_simple_clicked (AwnAppletSimple* _sender, gpointer self) {
	show_desktop_on_clicked (self);
}


static void _show_desktop_on_context_menu_popup_awn_applet_simple_context_menu_popup (AwnAppletSimple* _sender, GdkEventButton* event, gpointer self) {
	show_desktop_on_context_menu_popup (self, event);
}


static void _show_desktop_on_show_desktop_changed_wnck_screen_showing_desktop_changed (WnckScreen* _sender, gpointer self) {
	show_desktop_on_show_desktop_changed (self, _sender);
}


static gboolean _show_desktop_on_map_event_gtk_widget_map_event (GtkWidget* _sender, GdkEvent* event, gpointer self) {
	gboolean result;
	result = show_desktop_on_map_event (self, event);
	return result;
}


ShowDesktop* show_desktop_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id) {
	ShowDesktop * self = NULL;
	WnckScreen* screen = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_ = NULL;
	WnckScreen* _tmp4_ = NULL;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	self = (ShowDesktop*) g_object_new (object_type, "canonical-name", _tmp0_, "uid", _tmp1_, "panel-id", _tmp2_, NULL);
	_tmp3_ = _ ("Show Desktop");
	g_object_set ((AwnApplet*) self, "display-name", _tmp3_, NULL);
	g_signal_connect_object ((AwnAppletSimple*) self, "clicked", (GCallback) _show_desktop_on_clicked_awn_applet_simple_clicked, self, 0);
	g_signal_connect_object ((AwnAppletSimple*) self, "context-menu-popup", (GCallback) _show_desktop_on_context_menu_popup_awn_applet_simple_context_menu_popup, self, 0);
	_tmp4_ = wnck_screen_get_default ();
	screen = _tmp4_;
	g_signal_connect_object (screen, "showing-desktop-changed", (GCallback) _show_desktop_on_show_desktop_changed_wnck_screen_showing_desktop_changed, self, 0);
	show_desktop_on_show_desktop_changed (self, screen);
	g_signal_connect_object ((GtkWidget*) self, "map-event", (GCallback) _show_desktop_on_map_event_gtk_widget_map_event, self, 0);
	return self;
}


ShowDesktop* show_desktop_new (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	return show_desktop_construct (TYPE_SHOW_DESKTOP, canonical_name, uid, panel_id);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean show_desktop_on_map_event (ShowDesktop* self, GdkEvent* event) {
	gboolean result = FALSE;
	AwnIcon* _tmp0_ = NULL;
	AwnTooltip* _tmp1_ = NULL;
	AwnTooltip* _tmp2_;
	AwnTooltip* tooltip;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp1_ = awn_icon_get_tooltip (AWN_IS_ICON (_tmp0_) ? ((AwnIcon*) _tmp0_) : NULL);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	tooltip = _tmp2_;
	g_object_set (tooltip, "toggle-on-click", FALSE, NULL);
	result = TRUE;
	_g_object_unref0 (tooltip);
	return result;
}


static void show_desktop_on_clicked (ShowDesktop* self) {
	WnckScreen* screen = NULL;
	WnckScreen* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = wnck_screen_get_default ();
	screen = _tmp0_;
	_tmp1_ = wnck_screen_get_showing_desktop (screen);
	wnck_screen_toggle_showing_desktop (screen, !_tmp1_);
}


static void show_desktop_on_context_menu_popup (ShowDesktop* self, GdkEventButton* event) {
	GtkMenu* _tmp0_;
	GtkMenu* _tmp9_;
	AwnIcon* _tmp10_ = NULL;
	GtkMenu* _tmp11_;
	GdkEventButton _tmp12_;
	guint _tmp13_;
	GdkEventButton _tmp14_;
	guint32 _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	_tmp0_ = self->priv->_menu;
	if (_tmp0_ == NULL) {
		GtkWidget* about_item = NULL;
		GtkWidget* _tmp1_ = NULL;
		GtkMenu* _tmp2_;
		const gchar* _tmp3_ = NULL;
		GtkWidget* _tmp4_ = NULL;
		GtkWidget* _tmp5_;
		GtkWidget* _tmp6_;
		GtkMenu* _tmp7_;
		GtkWidget* _tmp8_;
		_tmp1_ = awn_applet_create_default_menu ((AwnApplet*) self);
		_tmp2_ = _g_object_ref0 (GTK_IS_MENU (_tmp1_) ? ((GtkMenu*) _tmp1_) : NULL);
		_g_object_unref0 (self->priv->_menu);
		self->priv->_menu = _tmp2_;
		_tmp3_ = _ ("Hides your windows and shows your desktop.");
		_tmp4_ = awn_applet_create_about_item ((AwnApplet*) self, "Copyright © 2009 Mark Lee", AWN_APPLET_LICENSE_GPLV2, VERSION, _tmp3_, NULL, NULL, "user-desktop", NULL, SHOW_DESKTOP_authors, NULL, NULL);
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_g_object_unref0 (about_item);
		about_item = _tmp5_;
		_tmp6_ = about_item;
		gtk_widget_show (_tmp6_);
		_tmp7_ = self->priv->_menu;
		_tmp8_ = about_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp7_, (GtkWidget*) (GTK_IS_MENU_ITEM (_tmp8_) ? ((GtkMenuItem*) _tmp8_) : NULL));
		_g_object_unref0 (about_item);
	}
	_tmp9_ = self->priv->_menu;
	gtk_menu_set_screen (_tmp9_, NULL);
	_tmp10_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp11_ = self->priv->_menu;
	_tmp12_ = *event;
	_tmp13_ = _tmp12_.button;
	_tmp14_ = *event;
	_tmp15_ = _tmp14_.time;
	awn_icon_popup_gtk_menu (_tmp10_, (GtkWidget*) _tmp11_, _tmp13_, _tmp15_);
}


static void show_desktop_on_show_desktop_changed (ShowDesktop* self, WnckScreen* screen) {
	WnckScreen* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = screen;
	_tmp1_ = wnck_screen_get_showing_desktop (_tmp0_);
	if (_tmp1_) {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = _ ("Show hidden windows");
		awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, _tmp2_);
		awn_applet_simple_set_icon_name ((AwnAppletSimple*) self, "view-restore");
	} else {
		const gchar* _tmp3_ = NULL;
		_tmp3_ = _ ("Hide windows and show desktop");
		awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, _tmp3_);
		awn_applet_simple_set_icon_name ((AwnAppletSimple*) self, "user-desktop");
	}
}


static void show_desktop_class_init (ShowDesktopClass * klass) {
	show_desktop_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ShowDesktopPrivate));
	G_OBJECT_CLASS (klass)->finalize = show_desktop_finalize;
}


static void show_desktop_instance_init (ShowDesktop * self) {
	self->priv = SHOW_DESKTOP_GET_PRIVATE (self);
}


static void show_desktop_finalize (GObject* obj) {
	ShowDesktop * self;
	self = SHOW_DESKTOP (obj);
	_g_object_unref0 (self->priv->_menu);
	G_OBJECT_CLASS (show_desktop_parent_class)->finalize (obj);
}


GType show_desktop_get_type (void) {
	static volatile gsize show_desktop_type_id__volatile = 0;
	if (g_once_init_enter (&show_desktop_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ShowDesktopClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) show_desktop_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ShowDesktop), 0, (GInstanceInitFunc) show_desktop_instance_init, NULL };
		GType show_desktop_type_id;
		show_desktop_type_id = g_type_register_static (AWN_TYPE_APPLET_SIMPLE, "ShowDesktop", &g_define_type_info, 0);
		g_once_init_leave (&show_desktop_type_id__volatile, show_desktop_type_id);
	}
	return show_desktop_type_id__volatile;
}


AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	AwnApplet* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	ShowDesktop* _tmp3_;
	AwnApplet* _tmp4_;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	_tmp3_ = show_desktop_new (_tmp0_, _tmp1_, _tmp2_);
	_tmp4_ = (AwnApplet*) g_object_ref_sink (_tmp3_);
	result = _tmp4_;
	return result;
}



